

































#
# Gnu as version of ciforth created by ``m4'' from generic listing.
# This 64-bit source can be assembled in the following way:
#       as lina.s
#       ld -N a.out -o lina -lc


 /* 
        A generic version of ISO FORTH for ARM processors
                Albert van der Horst/Frans van der Markt

                in cooperation with
                HCC Forth user group
                The Netherlands
                www.forth.hccnet.nl

              based on
              FIG-FORTH
   implemented by:  Charlie Krajewski
                    205 ( BIG ) Blue Rd.
                    Middletown, CT  06457

  The listing has been made possible by the
  prior work of:
               Thomas Newman, Hayward, Ca.

 : other_acknowledgements
         John_Cassidy
         Kim_Harris
         George_Flammer
         Robert_D._Villwock ;

 : for tools
         Richard M. Stallman
         Linus Torvalds

No one who programs with FORTH can afford to be without:
  "Starting Forth  by Leo Brodie" and "Thinking Forth by Leo Brodie".
   Both out of print, but saved on the internet.

This Forth is a descendant in the 300+ (RCS)- generations from fig-Forth.

For nostalgic reasons the following comment has never been removed:
   Although there is much to be said for typing in your own
   listing and getting it running, there is much to be said
   not typing in your own listing.  If you feel that 100+
   pages of plinking is nutty, contact me for availability
   of a disc with source & executable files.  Obtainable at
   a bargain basement price, prepare yourself for bargain
   basement support.

All publications of the FORTH Interest Group are public domain.
They may be further distributed by the inclusion of this
credit notice:
               This publication has been made available by:

               FORTH Interest Group
               P.O. Box 1105
               San Carlos, Ca.  94070
[I feel obliged to keep this last one in (AH). Note that although it is
based on fig-Forth no stone is left unturned.]
 */          #




FIGREL  =     5       
FIGREV  =     0       
USRVER  =     0      


CW      =     8    
ERRORSCREEN =     48    




NBUF    =     16   
KBBUF   =     1024      
US      =     0x40*CW  
EM      =     (0x4000000)     
EMP     =     (EM-1)/0x1000+1 
TAS     =     0x100000    
STACKSIZE   = TAS/4  
TIBSIZE     = TAS/4  






ABL     =     ' '     
ACR     =     0x0D     
AMS     =     '-'          
ASO     =     '['          
ASC     =     ']'          
ADOT    =     '.'          
ALF     =     0x0A     
AFF     =     0x0C     
BELL    =     0x07     
BSIN    =     0x08     
BSOUT   =     0x08     



B_DUMMY   =     0x01     
B_INVIS   =     0x02     
B_IMMED   =     0x04     
B_DENOT   =     0x08     
C_HOFFSET =     0       
D_HOFFSET =     1       
F_HOFFSET =     2       
L_HOFFSET =     3       
N_HOFFSET =     4       
S_HOFFSET =     5       
PH_OFFSET =     5+1   
BD_OFFSET =     5+1+1 
HEADSIZE  =     (CW*(PH_OFFSET))  

 


BPS     =     512             
SPB     =     KBBUF/BPS       














SEEK_SET	=	0x0
SEEK_CUR	=	0x1
TCGETS	=	0x5401
TCSETS	=	0x5402
ECHO	=	0x8
EAGAIN	=	0xb
EINTR	=	0x4
EPIPE	=	0x20
VMIN	=	0x6
VTIME	=	0x5
ICANON	=	0x2
O_RDWR	=	0x2
O_RDONLY	=	0x0
O_WRONLY	=	0x1
O_CREAT	=	0x40
O_TRUNC	=	0x200
O_NONBLOCK	=	0x800
WEXITED	=	0x4
P_PID	=	0x1
AT_FDCWD	=	0xffffff9c
AT_REMOVEDIR	=	0x200
MAP_SHARED	=	0x1
MAP_PRIVATE	=	0x2
SIZE_TERMIO	=	0x3c







exit	=	0x5d
openat	=	0x38
close	=	0x39
unlinkat	=	0x23
mmap	=	0xde
chdir	=	0x31
read	=	0x3f
pselect6	=	0x48
write	=	0x40
ioctl	=	0x1d
lseek	=	0x3e
execve	=	0xdd
waitid	=	0x5f
clone	=	0xdc
kill	=	0x81
times	=	0x99




select = pselect6     

RAWIO           =     (ECHO | ICANON)




_main:






        
        .text

        #
        .global  _start       
        .global  start        
_ORIG:
_start:      










NOBOOT:         


ENDBOOT:



















start:

COLD_ENTRY:

        ADR   X4, USINI
        MOV     X0, SP              
        STR     X0, [X4, #CW*(31)]




        ADR     X4, USINI
        LDR     X0, [X4, #CW*(2)]  
        MOV     X13, X0           
        LDR     X12, [X4, #CW*(3)]  
        ADR     X11, COLD + CW*(PH_OFFSET)    
      LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  











 /* 
   FORTH REGISTERS
   The names under FORTH are used in the generic source.

   FORTH   ARM      FORTH PRESERVATION RULES
   -----   ----     ----- ------------ -----
           X0-X3   Used within and cluttered by Forth words.
                    across FORTH words.
                    The first of those is WOR (probably)

   WOR   X0      Working register.  When entering a word
                    via its code field the DEA is passed in WOR.

            X0      Scratch register.  Used to pass data from
                    FORTH words, see label APUSH or macro _APUSH

            X1      General register.  Used when two data items are passed
                    from FORTH words, see label DPUSH or macro _DPUSH

   HIP   X11      High level Interpreter Pointer.  Must be preserved

   RPO   X12      Return stack pointer.  Must be preserved across
                    FORTH words.

   SPO   X13      Parameter stack pointer.  Must be preserved
                    across FORTH words.

           PC       Machine Process Counter, sometimes used
                    for relative addressing

This is the ARM asignment, not valid for 64 bit.

   X13     SP      ARM stack pointer.
                   In thumb this can be used with pop and push.

   X14     RL      Machine Link Register for calls.
                    Can be used within Forth words, with care.

  X15     PC        Machine Process Counter (Program counter)
                    Cannot be used within Forth words.



            The remaining registers are free to use.
            X0-X3 are the normal Forth work registers.
            Within assembler words X0 can be used too,
            as it has served its purpose.

            Here are some  useful code sequences.
            For next:
                    LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  
            For push single and next:
                    STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  
            For push double and next:
                    STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  



----------------------------------------------------------
 */          #
 /* 
---------------------------------------------

   COMMENT CONVENTIONS
   ------- -----------

   =       IS EQUAL TO
   <-      ASSIGNMENT

  NAME        =  Address of name
  (NAME)      =  Contents of name
  DEA         =  DICTIONARY ENTRY ADDRESS
                 fields have fixed offsets from DEA
  CFA         =  CODE FIELD ADDRESS : a pointer to executable code
  DFA         =  DATA FIELD ADDRESS : a pointer to
                        data/high level code/ DOES> pointer
  FFA         =  FLAG FIELD ADDRESS: contains flags
  LFA         =  LINK FIELD ADDRESS: a pointer to the next DEA
  NFA         =  NAME FIELD ADDRESS: a pointer to a name buffer
  SFA =  SOURCE FIELD ADDRESS: a pointer into source code
  PHA         =  POST HEADER ADDRESS: After all fields

  S1          =  Parameter stack - 1st cell
  S2          =  Parameter stack - 2nd cell
  RP1          =  Return stack    - 1st cell
  X2          =  Return stack    - 2nd cell

  LSB         =  Least significant bit
  MSB         =  Most  significant bit
  LB          =  Low byte
  HB          =  High byte
  LC          =  Low  cell
  HC          =  High cell

------------------------------------------------------------
 */  
        #





DPUSH:  STR     X1, [X13,#-(CW*(1))]!      
APUSH:  STR     X0, [X13,#-(CW*(1))]!
NEXT:

        LDR     X0, [X11],#+(CW*(1))                  
NEXT1:
        LDR     X1, [X0]
        BR      X1     








        .align 3
N_ONLY:
        .xword      4
        .ascii      "ONLY"
        .align 3
ONLY:
        .xword    DODOE
        .xword    ONLY+HEADSIZE
        .xword    0x0
        .xword    0
        .xword    N_ONLY
        .xword    0

        .xword      DOVOC
        .xword      FORTH     
ONLYBODY:

        .align 3

        .xword    0x0
        .xword    0
        .xword    B_DUMMY
        .xword    STARTOFONLY
        .xword    (ZERO+(CW*(D_HOFFSET)))
        .xword    0







        .align 3
N_ENV:
        .xword      11
        .ascii      "ENVIRONMENT"
        .align 3
ENV:
        .xword    DODOE
        .xword    ENV+HEADSIZE
        .xword    0x0
        .xword    ONLY
        .xword    N_ENV
        .xword    0

        .xword      DOVOC
        .xword      ONLY       

        .align 3

        .xword    0x0
        .xword    0
        .xword    B_DUMMY
        .xword    STARTOFENVIRONMENT
        .xword    (ZERO+(CW*(D_HOFFSET)))
        .xword    0







        .align 3
N_COLD:
        .xword      4
        .ascii      "COLD"
        .align 3
COLD:
        .xword    DOCOL
        .xword    COLD+HEADSIZE
        .xword    0x0
        .xword    ENV
        .xword    N_COLD
        .xword    0


        .xword      LIT, USINI      
        .xword      LIT, USINI+(CW*(1)), FETCH
        .xword      LIT, US
        .xword      LCMOVE
        .xword      INIT
        .xword      ONE            


        .xword      ZERO, LIT, TCGETS, TERMIO
        .xword      LIT, ioctl, XOS, ZLESS
        .xword      ZBRAN
        .xword      COLD1-.-CW
        
        .xword      DROP, ZERO      
        .xword      LIT,TASK  
        .xword      LIT,OK
        .xword      LIT, (CW*(3)), LCMOVE
COLD1:
 

        .xword      SKIP
         .xword      8
SB0: .ascii      "/dev/mem"
       .align 3
        .xword      LIT, SB0
        .xword      LIT, 8
        .xword      LIT, 0x00181002
        .xword      OFILE, LOR, DEVMEM, STOR

       .xword      OPTIONS
        .xword      ZBRAN
        .xword      COLD5-.-CW

        .xword      SIGNON    
COLD5:
        .xword      ABORT
        .xword      BYE     
        .xword      SEMIS   






        .align 3
N_USER:
        .xword      4
        .ascii      "USER"
        .align 3
USER:
        .xword    DOCOL
        .xword    USER+HEADSIZE
        .xword    0x0
        .xword    COLD
        .xword    N_USER
        .xword    0

        .xword      LCONST
        .xword      PSCOD
DOUSE:  LDR     X3,[X0, # + (CW*((D_HOFFSET)))] 
        ADR     X0, USINI
        LDR     X0,[X0]
        ADD     X0,X0,X3      
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  







        .align 3
N_PORIG:
        .xword      7
        .ascii      "+ORIGIN"
        .align 3
PORIG:
        .xword    DOCOL
        .xword    PORIG+HEADSIZE
        .xword    0x0
        .xword    USER
        .xword    N_PORIG
        .xword    0

        .xword      LIT
        .xword      USINI
        .xword      PLUS
        .xword      SEMIS








        ADR     X4, COLD
        MOV     X0, X4
        LDR     X1, [X0]
        BR      X1          
        .align 3

        ADR      X4, WARM
        MOV      X0,X4
        LDR     X1, [X0]          
        BR      X1
        .align 3
USINI:  .xword      STRUSA
        .xword      STRUSA  
        .xword      INITS0  
        .xword      INITR0  - (CW*(1))
                        
        .xword      STRTIB  
        .xword      BSIN    
        .xword      0       
        .xword      1       
        .xword      INITDP  
DPA:    .xword      INITDP  
        .xword      ENV 
        .xword      39+16        

        .xword      0, 0            
        .xword      0, 0            

        .space    US-(. - USINI)        









        .align 3
N_VMAIO:
        .xword      6
        .ascii      "VMA-IO"
        .align 3
VMAIO:
        .xword    DOVAR
        .xword    VMAIO+HEADSIZE
        .xword    0x0
        .xword    PORIG
        .xword    N_VMAIO
        .xword    0

        .xword 0xB2000000






        .align 3
N_PERIPHERALS:
        .xword      11
        .ascii      "PERIPHERALS"
        .align 3
PERIPHERALS:
        .xword    DOVAR
        .xword    PERIPHERALS+HEADSIZE
        .xword    0x0
        .xword    VMAIO
        .xword    N_PERIPHERALS
        .xword    0

        .xword 0x03000000






        .align 3
N_DEVMEM:
        .xword      7
        .ascii      "DEV-MEM"
        .align 3
DEVMEM:
        .xword    DOVAR
        .xword    DEVMEM+HEADSIZE
        .xword    0x0
        .xword    PERIPHERALS
        .xword    N_DEVMEM
        .xword    0

        .xword 0






        .align 3
N_MMAPIO:
        .xword      7
        .ascii      "MMAP-IO"
        .align 3
MMAPIO:
        .xword    DOCOL
        .xword    MMAPIO+HEADSIZE
        .xword    0x0
        .xword    DEVMEM
        .xword    N_MMAPIO
        .xword    0





      .xword     DEVMEM, FETCH, LDUP, ZERO, GREAT
      .xword      ZBRAN
        .xword      MMAP2-.-CW
      .xword     TOR
      .xword     VMAIO, FETCH
      .xword     LIT, 0x010000000 
      .xword     LIT, 3                  
      .xword     LIT, MAP_SHARED         
      .xword     FROMR
      .xword     PERIPHERALS, FETCH

      .xword     ZERO                
      .xword     LIT, mmap, XOS7
MMAP2:
      .xword     VMAIO, STOR
      .xword      SEMIS   









        .align 3
N_ABORT:
        .xword      5
        .ascii      "ABORT"
        .align 3
ABORT:
        .xword    DOCOL
        .xword    ABORT+HEADSIZE
        .xword    0x0
        .xword    MMAPIO
        .xword    N_ABORT
        .xword    0

        .xword      SZERO, FETCH, SPSTO
        .xword      ZERO, HANDLER, STOR
        .xword      QUIT
        .xword      SEMIS   







        .align 3
N_WARM:
        .xword      4
        .ascii      "WARM"
        .align 3
WARM:
        .xword    DOCOL
        .xword    WARM+HEADSIZE
        .xword    0x0
        .xword    ABORT
        .xword    N_WARM
        .xword    0

        .xword      INIT
        .xword      SIGNON
        .xword      ABORT
        .xword      SEMIS   






        .align 3
N_NOOP:
        .xword      4
        .ascii      "NOOP"
        .align 3
NOOP:
        .xword    NOOP+HEADSIZE
        .xword    NOOP+HEADSIZE
        .xword    0x0
        .xword    WARM
        .xword    N_NOOP
        .xword    0

       LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  








        .align 3
N_LIT:
        .xword      3
        .ascii      "LIT"
        .align 3
LIT:
        .xword    LIT+HEADSIZE
        .xword    LIT+HEADSIZE
        .xword    0x0
        .xword    NOOP
        .xword    N_LIT
        .xword    0

        LDR     X0, [X11],#+(CW*(1))                  
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            







        .align 3
N_EXEC:
        .xword      7
        .ascii      "EXECUTE"
        .align 3
EXEC:
        .xword    EXEC+HEADSIZE
        .xword    EXEC+HEADSIZE
        .xword    0x0
        .xword    LIT
        .xword    N_EXEC
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR    X1, [X0]
        BR     X1  







        .align 3
N_RECURSE:
        .xword      7
        .ascii      "RECURSE"
        .align 3
RECURSE:
        .xword    DOCOL
        .xword    RECURSE+HEADSIZE
        .xword    B_IMMED
        .xword    EXEC
        .xword    N_RECURSE
        .xword    0

        .xword      LATEST, COMMA
        .xword      SEMIS






        .align 3
N_BRAN:
        .xword      6
        .ascii      "BRANCH"
        .align 3
BRAN:
        .xword    (SKIP+HEADSIZE)
        .xword    BRAN+HEADSIZE
        .xword    0x0
        .xword    RECURSE
        .xword    N_BRAN
        .xword    0







        .align 3
N_SKIP:
        .xword      4
        .ascii      "SKIP"
        .align 3
SKIP:
        .xword    SKIP+HEADSIZE
        .xword    SKIP+HEADSIZE
        .xword    0x0
        .xword    BRAN
        .xword    N_SKIP
        .xword    0

BRAN1:
        LDR     X0, [X11],#+(CW*(1))                  

        SUB     X0,X0, #1
        
         ORR     X0,X0, #(CW-1) 
        ADD     X0,X0, #1

        ADD     X11,X11,X0
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_ZBRAN:
        .xword      7
        .ascii      "0BRANCH"
        .align 3
ZBRAN:
        .xword    ZBRAN+HEADSIZE
        .xword    ZBRAN+HEADSIZE
        .xword    0x0
        .xword    SKIP
        .xword    N_ZBRAN
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        ANDS     X0,X0,X0   
        BEQ      BRAN1   
        ADD      X11,X11,# + (CW*(1))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_XPLOOP:
        .xword      7
        .ascii      "(+LOOP)"
        .align 3
XPLOOP:
        .xword    XPLOOP+HEADSIZE
        .xword    XPLOOP+HEADSIZE
        .xword    0x0
        .xword    ZBRAN
        .xword    N_XPLOOP
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X2,[X12]  
        ADD     X2,X2,X3
        STR     X2,[X12]  
        LDR     X4, [X12, #+(CW*(1))]
        SUB     X2,X2,X4  
        EOR     X2,X2,X3  
        ANDS    X2,X2,X2  
        EOR     X0,X0,X0  
        BMI     XPO1     
        SUB     X0,X0, #1      
XPO1: STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_XDO:
        .xword      4
        .ascii      "(DO)"
        .align 3
XDO:
        .xword    XDO+HEADSIZE
        .xword    XDO+HEADSIZE
        .xword    0x0
        .xword    XPLOOP
        .xword    N_XDO
        .xword    0

        LDR     X2, [X11],#+(CW*(1))                  
        ADD     X2,X2,X11  
        LDR     X1, [X13],#+(CW*(1))           
        LDR     X3, [X13],#+(CW*(1))           
        
         MOV     X0, X12
         MOV     X12, X13
         MOV     X13, X0
   
        STR     X2, [X13,#-(CW*(1))]!      
        STR     X3, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        
         MOV     X0, X12
         MOV     X12, X13
         MOV     X13, X0
   
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_XQDO:
        .xword      5
        .ascii      "(?DO)"
        .align 3
XQDO:
        .xword    XQDO+HEADSIZE
        .xword    XQDO+HEADSIZE
        .xword    0x0
        .xword    XDO
        .xword    N_XQDO
        .xword    0

        LDR     X2, [X11],#+(CW*(1))                  
        ADD     X2,X2,X11  
        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        CMP     X1,X3
        BGE     QXDO1
        
         MOV     X0, X12
         MOV     X12, X13
         MOV     X13, X0
   
        STR     X2, [X13,#-(CW*(1))]!      
        STR     X3, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        
         MOV     X0, X12
         MOV     X12, X13
         MOV     X13, X0
   
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  
QXDO1:  MOV     X11,X2
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_IDO:
        .xword      1
        .ascii      "I"
        .align 3
IDO:
        .xword    IDO+HEADSIZE
        .xword    IDO+HEADSIZE
        .xword    0x0
        .xword    XQDO
        .xword    N_IDO
        .xword    0

        LDR     X0,[X12] 
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            






        .align 3
N_JDO:
        .xword      1
        .ascii      "J"
        .align 3
JDO:
        .xword    JDO+HEADSIZE
        .xword    JDO+HEADSIZE
        .xword    0x0
        .xword    IDO
        .xword    N_JDO
        .xword    0

        LDR     X0,[X12,#+(CW*(3))] 
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            






        .align 3
N_UNLOOP:
        .xword      6
        .ascii      "UNLOOP"
        .align 3
UNLOOP:
        .xword    UNLOOP+HEADSIZE
        .xword    UNLOOP+HEADSIZE
        .xword    0x0
        .xword    JDO
        .xword    N_UNLOOP
        .xword    0
      
        ADD X12,X12,#(CW*(3))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_DIGIT:
        .xword      5
        .ascii      "DIGIT"
        .align 3
DIGIT:
        .xword    DIGIT+HEADSIZE
        .xword    DIGIT+HEADSIZE
        .xword    0x0
        .xword    UNLOOP
        .xword    N_DIGIT
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        AND     X0,X0,#0xFF
        AND     X1,X1,#0xFF
        SUBS    X0,X0,#'0'
        BLT     DIGI2   
        CMP     X0,#9
        BLE     DIGI1   
        SUB     X0,X0,#7
        CMP     X0,#10   
        BLT     DIGI2   
DIGI1:  CMP     X0,X1   
        BGE     DIGI2   
        MOV     X1,X0   
        
        MOV    X0,#-1  
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            

DIGI2:  MOV    X0, #0 
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_NMATCH:
        .xword      6
        .ascii      "~MATCH"
        .align 3
NMATCH:
        .xword    DOCOL
        .xword    NMATCH+HEADSIZE
        .xword    0x0
        .xword    DIGIT
        .xword    N_NMATCH
        .xword    0


        .xword      TOR                           
        .xword      OVER
        .xword      RR, TNFA, FETCH, SFET
        .xword      CORA
        .xword      FROMR, SWAP                   
        .xword      SEMIS                            






        .align 3
N_QBL:
        .xword      6
        .ascii      "?BLANK"
        .align 3
QBL:
        .xword    DOCOL
        .xword    QBL+HEADSIZE
        .xword    0x0
        .xword    NMATCH
        .xword    N_QBL
        .xword    0

        .xword      LBL, ONEP, LESS
        .xword      SEMIS






        .align 3
N_PPFET:
        .xword      4
        .ascii      "PP@@"
        .align 3
PPFET:
        .xword    DOCOL
        .xword    PPFET+HEADSIZE
        .xword    0x0
        .xword    QBL
        .xword    N_PPFET
        .xword    0

        .xword      SRC, CELLP, TFET
        .xword      OVER, EQUAL
        .xword      ZBRAN
        .xword      PPFET1-.-CW
        .xword      ZERO
        .xword      BRAN
        .xword      PPFET2-.-CW
PPFET1:
        .xword      LDUP
        
        .xword      CFET
        .xword      ONE, PP, PSTOR
PPFET2:
        .xword      SEMIS






        .align 3
N_LNAME:
        .xword      4
        .ascii      "NAME"
        .align 3
LNAME:
        .xword    DOCOL
        .xword    LNAME+HEADSIZE
        .xword    0x0
        .xword    PPFET
        .xword    N_LNAME
        .xword    0

        .xword      X
PWORD0: .xword      DROP
        .xword      PPFET, QBL
        .xword      OVER, SRC, CELLP, FETCH, LSUB 
        .xword      LAND, ZEQU
        .xword      ZBRAN
        .xword      PWORD0-.-CW

        .xword      X
PWORD1: .xword      DROP
        .xword      PPFET, QBL
        .xword      ZBRAN
        .xword      PWORD1-.-CW

        .xword      OVER, LSUB
        
        .xword      SEMIS






        .align 3
N_PARSE:
        .xword      5
        .ascii      "PARSE"
        .align 3
PARSE:
        .xword    DOCOL
        .xword    PARSE+HEADSIZE
        .xword    0x0
        .xword    LNAME
        .xword    N_PARSE
        .xword    0

        .xword      SRC, CELLP, TFET
        .xword      OVER, LSUB
        
        .xword      ROT, SSLAS, TSWAP
        .xword      ZEQU
        .xword      ZBRAN
        .xword      PARSE8-.-CW
        .xword      DROP, SRC, CELLP, FETCH
PARSE8: 
        .xword      PP, STOR
        .xword SEMIS






        .align 3
N_SRC:
        .xword      3
        .ascii      "SRC"
        .align 3
SRC:
        .xword    DOUSE
        .xword    (CW*(27))
        .xword    0x0
        .xword    PARSE
        .xword    N_SRC
        .xword    0
      






        .align 3
N_SOURCE:
        .xword      6
        .ascii      "SOURCE"
        .align 3
SOURCE:
        .xword    DOCOL
        .xword    SOURCE+HEADSIZE
        .xword    0x0
        .xword    SRC
        .xword    N_SOURCE
        .xword    0

        .xword      SRC, TFET
        .xword      SWAP, OVER, LSUB
        .xword      SEMIS








        .align 3
N_CR:
        .xword      2
        .ascii      "CR"
        .align 3
CR:
        .xword    DOCOL
        .xword    CR+HEADSIZE
        .xword    0x0
        .xword    SOURCE
        .xword    N_CR
        .xword    0

        .xword      LIT,ALF
        .xword      EMIT
        .xword      ZERO, LOUT, STOR
        .xword      SEMIS






        .align 3
N_LCMOVE:
        .xword      5
        .ascii      "CMOVE"
        .align 3
LCMOVE:
        .xword    LCMOVE+HEADSIZE
        .xword    LCMOVE+HEADSIZE
        .xword    0x0
        .xword    CR
        .xword    N_LCMOVE
        .xword    0

        MOV     X8,X11   
        LDR     X2, [X13],#+(CW*(1))      
        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        CMP X2, #0
        BEQ MOVRP2
MOVREP: LDRB    W0, [X3],#+1
        STRB    W0, [X1],#+1
        SUBS    X2,X2, #1
        BNE     MOVREP
MOVRP2: MOV     X11,X8   
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_LMOVE:
        .xword      4
        .ascii      "MOVE"
        .align 3
LMOVE:
        .xword    LMOVE+HEADSIZE
        .xword    LMOVE+HEADSIZE
        .xword    0x0
        .xword    LCMOVE
        .xword    N_LMOVE
        .xword    0

        LDR     X2, [X13],#+(CW*(1))      
        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        ANDS    X3,X3,X3   
        BEQ     MOVE3
        ANDS    X1,X1,X1
        BEQ     MOVE3
        ANDS    X2,X2,X2
        BEQ     MOVE3
        CMP     X3,X1
        BHI     MOVE2
        ADD     X1,X1,X2
        ADD     X3,X3,X2
        SUB     X1,X1, #1
        SUB     X3,X3, #1
MOVE1:
        LDRB    W0, [X3],#-1
        STRB    W0, [X1],#-1
        SUBS    X2,X2, #1
        BNE     MOVE1
        B     MOVE3
MOVE2:
        LDRB    W0, [X3],#+1
        STRB    W0, [X1],#+1
        SUBS    X2,X2, #1
        BNE     MOVE2
MOVE3:
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_USTAR:
        .xword      3
        .ascii      "UM*"
        .align 3
USTAR:
        .xword    USTAR+HEADSIZE
        .xword    USTAR+HEADSIZE
        .xword    0x0
        .xword    LMOVE
        .xword    N_USTAR
        .xword    0

        LDR     X2, [X13],#+(CW*(1))
        LDR     X3, [X13],#+(CW*(1))
 
        MUL      X1,X3,X2          
        UMULH    X0,X3,X2          
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            






        .align 3
N_USLAS:
        .xword      6
        .ascii      "UM/MOD"
        .align 3
USLAS:
        .xword    USLAS+HEADSIZE
        .xword    USLAS+HEADSIZE
        .xword    0x0
        .xword    USTAR
        .xword    N_USLAS
        .xword    0

        LDR     X2, [X13],#+(CW*(1))      
        LDR     X1, [X13],#+(CW*(1))     
        LDR     X0, [X13],#+(CW*(1))      
        BL UMDIV
        STR     X1, [X13,#-(CW*(1))]!    
        STR     X4, [X13,#-(CW*(1))]!     
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  

 /* 
_BITS_32(  division of unsigned-64/unsigned-32)
_BITS_64(  division of unsigned-128/unsigned-64)
  input:
  div  = X2  = divisor
  modh = X1 = MSW of dividend
  modl = X0  = LSW of dividend
  output:
  quot = X0  = quotient
  rem = X1 = remainder

  Internally X3 is used as a mask, with 1 bit set.
  mask = X3

 */  
UMDIV:  STR     X30, [X13,#-(CW*(1))]!
        MOV X3, #1
        LSL X3,X3, #(CW*8-1)  
        MOV X4, #0              
        CMP X1, X2             
        BLO UMDIV1              
        
        ASR  X4, X3, #(CW*8-1) 
        MOV  X1, X4


        B  UMDIV3             

UMDIV1:
        ADDS X0,X0, X0         
        ADCS X1,X1, X1      
        BCS  UMDIV4
        CMP  X2, X1            
        BHI  UMDIV2             
UMDIV4:
        ADD  X4,X4, X3         
        SUB  X1,X1, X2       
UMDIV2:
        LSR X3,X3, #1          
        ANDS  X3,X3,X3
        BNE  UMDIV1
UMDIV3:
        
                        LDR     X2, [X13],#+(CW*(1))
        BR X2








        .align 3
N_LAND:
        .xword      3
        .ascii      "AND"
        .align 3
LAND:
        .xword    LAND+HEADSIZE
        .xword    LAND+HEADSIZE
        .xword    0x0
        .xword    USLAS
        .xword    N_LAND
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X3, [X13],#+(CW*(1))
        AND     X0,X0,X3
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_LOR:
        .xword      2
        .ascii      "OR"
        .align 3
LOR:
        .xword    LOR+HEADSIZE
        .xword    LOR+HEADSIZE
        .xword    0x0
        .xword    LAND
        .xword    N_LOR
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))
        ORR      X0,X0,X3
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_LXOR:
        .xword      3
        .ascii      "XOR"
        .align 3
LXOR:
        .xword    LXOR+HEADSIZE
        .xword    LXOR+HEADSIZE
        .xword    0x0
        .xword    LOR
        .xword    N_LXOR
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))
        EOR     X0,X0,X3
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_INVERT:
        .xword      6
        .ascii      "INVERT"
        .align 3
INVERT:
        .xword    INVERT+HEADSIZE
        .xword    INVERT+HEADSIZE
        .xword    0x0
        .xword    LXOR
        .xword    N_INVERT
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        MOV X1,#0
        SUB X1,X1,#1
        EOR X0,X0,X1
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SPFET:
        .xword      4
        .ascii      "DSP@"
        .align 3
SPFET:
        .xword    SPFET+HEADSIZE
        .xword    SPFET+HEADSIZE
        .xword    0x0
        .xword    INVERT
        .xword    N_SPFET
        .xword    0

        MOV     X0,X13   
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SPSTO:
        .xword      4
        .ascii      "DSP!"
        .align 3
SPSTO:
        .xword    SPSTO+HEADSIZE
        .xword    SPSTO+HEADSIZE
        .xword    0x0
        .xword    SPFET
        .xword    N_SPSTO
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        MOV     X13,X0        
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_DEPTH:
        .xword      5
        .ascii      "DEPTH"
        .align 3
DEPTH:
        .xword    DOCOL
        .xword    DEPTH+HEADSIZE
        .xword    0x0
        .xword    SPSTO
        .xword    N_DEPTH
        .xword    0

        .xword      SZERO, FETCH
        .xword      SPFET
        .xword      LSUB
        .xword      LIT, CW, SLASH
        .xword      ONEM
        .xword      SEMIS






        .align 3
N_CLS:
        .xword      3
        .ascii      "CLS"
        .align 3
CLS:
        .xword    DOCOL
        .xword    CLS+HEADSIZE
        .xword    0x0
        .xword    DEPTH
        .xword    N_CLS
        .xword    0

        .xword      SZERO, FETCH
        .xword      SPSTO
        .xword      SEMIS






        .align 3
N_RPFET:
        .xword      4
        .ascii      "RSP@"
        .align 3
RPFET:
        .xword    RPFET+HEADSIZE
        .xword    RPFET+HEADSIZE
        .xword    0x0
        .xword    CLS
        .xword    N_RPFET
        .xword    0
      
        STR     X12, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_RPSTO:
        .xword      4
        .ascii      "RSP!"
        .align 3
RPSTO:
        .xword    RPSTO+HEADSIZE
        .xword    RPSTO+HEADSIZE
        .xword    0x0
        .xword    RPFET
        .xword    N_RPSTO
        .xword    0

        LDR     X12, [X13],#+(CW*(1))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_EXIT:
        .xword      4
        .ascii      "EXIT"
        .align 3
EXIT:
        .xword    EXIT+HEADSIZE
        .xword    EXIT+HEADSIZE
        .xword    0x0
        .xword    RPSTO
        .xword    N_EXIT
        .xword    0

        LDR     X11, [X12],#+(CW*(1))  
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_CO:
        .xword      2
        .ascii      "CO"
        .align 3
CO:
        .xword    CO+HEADSIZE
        .xword    CO+HEADSIZE
        .xword    0x0
        .xword    EXIT
        .xword    N_CO
        .xword    0

        LDR     X1,[X12]
        STR     X11, [X12]
        MOV     X11, X1
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SEMIS:
        .xword      3
        .ascii      "(;)"
        .align 3
SEMIS:
        .xword    (EXIT+HEADSIZE)
        .xword    SEMIS+HEADSIZE
        .xword    0x0
        .xword    CO
        .xword    N_SEMIS
        .xword    0







        .align 3
N_LLEAV:
        .xword      5
        .ascii      "LEAVE"
        .align 3
LLEAV:
        .xword    DOCOL
        .xword    LLEAV+HEADSIZE
        .xword    0x0
        .xword    SEMIS
        .xword    N_LLEAV
        .xword    0
  
        .xword      UNLOOP
        .xword      SEMIS






        .align 3
N_TOR:
        .xword      2
        .ascii      ">R"
        .align 3
TOR:
        .xword    TOR+HEADSIZE
        .xword    TOR+HEADSIZE
        .xword    0x0
        .xword    LLEAV
        .xword    N_TOR
        .xword    0
        
        LDR     X3, [X13],#+(CW*(1))      
        SUB     X12, X12, #(CW*(1))  
        STR     X3, [X12]            
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_FROMR:
        .xword      2
        .ascii      "R>"
        .align 3
FROMR:
        .xword    FROMR+HEADSIZE
        .xword    FROMR+HEADSIZE
        .xword    0x0
        .xword    TOR
        .xword    N_FROMR
        .xword    0
      
        LDR     X0,[X12] 
        ADD     X12,X12,# (CW*(1))
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_RDROP:
        .xword      5
        .ascii      "RDROP"
        .align 3
RDROP:
        .xword    RDROP+HEADSIZE
        .xword    RDROP+HEADSIZE
        .xword    0x0
        .xword    FROMR
        .xword    N_RDROP
        .xword    0
      
        ADD X12,X12,#(CW*(1))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_RR:
        .xword      2
        .ascii      "R@"
        .align 3
RR:
        .xword    (IDO+HEADSIZE)
        .xword    RR+HEADSIZE
        .xword    0x0
        .xword    RDROP
        .xword    N_RR
        .xword    0







        .align 3
N_ZEQU:
        .xword      2
        .ascii      "0="
        .align 3
ZEQU:
        .xword    ZEQU+HEADSIZE
        .xword    ZEQU+HEADSIZE
        .xword    0x0
        .xword    RR
        .xword    N_ZEQU
        .xword    0

        LDR     X2, [X13],#+(CW*(1))
        MOV    X0, #0   
        CMP     X2, #0
        BNE ZEQ1
        SUB     X0,X0, #1          
ZEQ1:   STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_ZLESS:
        .xword      2
        .ascii      "0<"
        .align 3
ZLESS:
        .xword    ZLESS+HEADSIZE
        .xword    ZLESS+HEADSIZE
        .xword    0x0
        .xword    ZEQU
        .xword    N_ZLESS
        .xword    0

        LDR     X1, [X13],#+(CW*(1))
        MOV    X0,#0    
        ANDS    X1,X1,X1   
        BPL     ZLESS1
        SUB     X0,X0, #1      
ZLESS1: STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PLUS:
        .xword      1
        .ascii      "+"
        .align 3
PLUS:
        .xword    PLUS+HEADSIZE
        .xword    PLUS+HEADSIZE
        .xword    0x0
        .xword    ZLESS
        .xword    N_PLUS
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))
        ADD     X0,X0,X3
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_DPLUS:
        .xword      2
        .ascii      "D+"
        .align 3
DPLUS:
        .xword    DPLUS+HEADSIZE
        .xword    DPLUS+HEADSIZE
        .xword    0x0
        .xword    PLUS
        .xword    N_DPLUS
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        LDR     X2, [X13],#+(CW*(1))      
        ADDS    X1,X1,X2
        ADCS    X0,X0,X3   
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_NEGATE:
        .xword      6
        .ascii      "NEGATE"
        .align 3
NEGATE:
        .xword    NEGATE+HEADSIZE
        .xword    NEGATE+HEADSIZE
        .xword    0x0
        .xword    DPLUS
        .xword    N_NEGATE
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        MVN X0, X0  
        ADD X0,X0,#1
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_DNEGA:
        .xword      7
        .ascii      "DNEGATE"
        .align 3
DNEGA:
        .xword    DNEGA+HEADSIZE
        .xword    DNEGA+HEADSIZE
        .xword    0x0
        .xword    NEGATE
        .xword    N_DNEGA
        .xword    0

        LDR     X0, [X13],#+(CW*(1))   
        LDR     X1, [X13],#+(CW*(1))   
        MVN X0, X0  
        MVN X1, X1
        
        ADDS X1, X1, #1  
        ADC X0, X0, XZR  
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  

        #






        .align 3
N_OVER:
        .xword      4
        .ascii      "OVER"
        .align 3
OVER:
        .xword    OVER+HEADSIZE
        .xword    OVER+HEADSIZE
        .xword    0x0
        .xword    DNEGA
        .xword    N_OVER
        .xword    0

        LDR     X1, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        STR     X0, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_DROP:
        .xword      4
        .ascii      "DROP"
        .align 3
DROP:
        .xword    DROP+HEADSIZE
        .xword    DROP+HEADSIZE
        .xword    0x0
        .xword    OVER
        .xword    N_DROP
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_NIP:
        .xword      3
        .ascii      "NIP"
        .align 3
NIP:
        .xword    NIP+HEADSIZE
        .xword    NIP+HEADSIZE
        .xword    0x0
        .xword    DROP
        .xword    N_NIP
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X3, [X13],#+(CW*(1))
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TDROP:
        .xword      5
        .ascii      "2DROP"
        .align 3
TDROP:
        .xword    TDROP+HEADSIZE
        .xword    TDROP+HEADSIZE
        .xword    0x0
        .xword    NIP
        .xword    N_TDROP
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SWAP:
        .xword      4
        .ascii      "SWAP"
        .align 3
SWAP:
        .xword    SWAP+HEADSIZE
        .xword    SWAP+HEADSIZE
        .xword    0x0
        .xword    TDROP
        .xword    N_SWAP
        .xword    0

        LDR     X1, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_LDUP:
        .xword      3
        .ascii      "DUP"
        .align 3
LDUP:
        .xword    LDUP+HEADSIZE
        .xword    LDUP+HEADSIZE
        .xword    0x0
        .xword    SWAP
        .xword    N_LDUP
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        STR     X0, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TDUP:
        .xword      4
        .ascii      "2DUP"
        .align 3
TDUP:
        .xword    TDUP+HEADSIZE
        .xword    TDUP+HEADSIZE
        .xword    0x0
        .xword    LDUP
        .xword    N_TDUP
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X1, [X13],#+(CW*(1))
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TSWAP:
        .xword      5
        .ascii      "2SWAP"
        .align 3
TSWAP:
        .xword    TSWAP+HEADSIZE
        .xword    TSWAP+HEADSIZE
        .xword    0x0
        .xword    TDUP
        .xword    N_TSWAP
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X2, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LDR     X1, [X13],#+(CW*(1))
        STR     X2, [X13,#-(CW*(1))]!
        STR     X3, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TOVER:
        .xword      5
        .ascii      "2OVER"
        .align 3
TOVER:
        .xword    TOVER+HEADSIZE
        .xword    TOVER+HEADSIZE
        .xword    0x0
        .xword    TSWAP
        .xword    N_TOVER
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X2, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LDR     X1, [X13],#+(CW*(1))
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        STR     X2, [X13,#-(CW*(1))]!
        STR     X3, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PSTOR:
        .xword      2
        .ascii      "+!"
        .align 3
PSTOR:
        .xword    PSTOR+HEADSIZE
        .xword    PSTOR+HEADSIZE
        .xword    0x0
        .xword    TOVER
        .xword    N_PSTOR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        LDR     X2, [X3]
        ADD     X2,X2, X0
        STR     X2, [X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TOGGL:
        .xword      6
        .ascii      "TOGGLE"
        .align 3
TOGGL:
        .xword    TOGGL+HEADSIZE
        .xword    TOGGL+HEADSIZE
        .xword    0x0
        .xword    PSTOR
        .xword    N_TOGGL
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        LDR     X1, [X3]
        EOR     X1,X1, X0
        STR     X1, [X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_FETCH:
        .xword      1
        .ascii      "@"
        .align 3
FETCH:
        .xword    FETCH+HEADSIZE
        .xword    FETCH+HEADSIZE
        .xword    0x0
        .xword    TOGGL
        .xword    N_FETCH
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X0,[X3]
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PFETCH:
        .xword      2
        .ascii      "P@"
        .align 3
PFETCH:
        .xword    PFETCH+HEADSIZE
        .xword    PFETCH+HEADSIZE
        .xword    0x0
        .xword    FETCH
        .xword    N_PFETCH
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X0,[X3]
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  







        .align 3
N_LFETCH:
        .xword      2
        .ascii      "L@"
        .align 3
LFETCH:
        .xword    LFETCH+HEADSIZE
        .xword    LFETCH+HEADSIZE
        .xword    0x0
        .xword    PFETCH
        .xword    N_LFETCH
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        EOR     X0,X0,X0
        LDR     W0,[X3]
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  









        .align 3
N_BITCLR:
        .xword      3
        .ascii      "BIC"
        .align 3
BITCLR:
        .xword    BITCLR+HEADSIZE
        .xword    BITCLR+HEADSIZE
        .xword    0x0
        .xword    LFETCH
        .xword    N_BITCLR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LDR     W2,[X3]
        BIC     X2,X2,X0
        STR     W2,[X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_BITSET:
        .xword      3
        .ascii      "BIS"
        .align 3
BITSET:
        .xword    BITSET+HEADSIZE
        .xword    BITSET+HEADSIZE
        .xword    0x0
        .xword    BITCLR
        .xword    N_BITSET
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LDR     W2,[X3]
        ORR     X2,X2,X0
        STR     W2,[X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  







        .align 3
N_CFET:
        .xword      2
        .ascii      "C@"
        .align 3
CFET:
        .xword    CFET+HEADSIZE
        .xword    CFET+HEADSIZE
        .xword    0x0
        .xword    BITSET
        .xword    N_CFET
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDRB    W0,[X3]
        
         AND     X0,X0, #0xFF
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TFET:
        .xword      2
        .ascii      "2@"
        .align 3
TFET:
        .xword    TFET+HEADSIZE
        .xword    TFET+HEADSIZE
        .xword    0x0
        .xword    CFET
        .xword    N_TFET
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0,[X3]                      
        LDR     X1,[X3,# + (CW*(1))]        
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_STOR:
        .xword      1
        .ascii      "!"
        .align 3
STOR:
        .xword    STOR+HEADSIZE
        .xword    STOR+HEADSIZE
        .xword    0x0
        .xword    TFET
        .xword    N_STOR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STR     X0, [X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PRTSTR:
        .xword      2
        .ascii      "P!"
        .align 3
PRTSTR:
        .xword    PRTSTR+HEADSIZE
        .xword    PRTSTR+HEADSIZE
        .xword    0x0
        .xword    STOR
        .xword    N_PRTSTR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STR     X0, [X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  







        .align 3
N_LSTOR:
        .xword      2
        .ascii      "L!"
        .align 3
LSTOR:
        .xword    LSTOR+HEADSIZE
        .xword    LSTOR+HEADSIZE
        .xword    0x0
        .xword    PRTSTR
        .xword    N_LSTOR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STR     W0, [X3]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  







        .align 3
N_CSTOR:
        .xword      2
        .ascii      "C!"
        .align 3
CSTOR:
        .xword    CSTOR+HEADSIZE
        .xword    CSTOR+HEADSIZE
        .xword    0x0
        .xword    LSTOR
        .xword    N_CSTOR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STRB         W0, [X3]  
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_TSTOR:
        .xword      2
        .ascii      "2!"
        .align 3
TSTOR:
        .xword    TSTOR+HEADSIZE
        .xword    TSTOR+HEADSIZE
        .xword    0x0
        .xword    CSTOR
        .xword    N_TSTOR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STR     X0, [X3]
        LDR     X0, [X13],#+(CW*(1))      
        STR     X0, [X3, # +(CW*(1))]
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_WITHIN:
        .xword      6
        .ascii      "WITHIN"
        .align 3
WITHIN:
        .xword    DOCOL
        .xword    WITHIN+HEADSIZE
        .xword    0x0
        .xword    TSTOR
        .xword    N_WITHIN
        .xword    0

        .xword      OVER, LSUB, TOR
        .xword      LSUB, FROMR
        .xword      ULESS
        .xword      SEMIS







        .align 3
N_COLON:
        .xword      1
        .ascii      ":"
        .align 3
COLON:
        .xword    DOCOL
        .xword    COLON+HEADSIZE
        .xword    0x0
        .xword    WITHIN
        .xword    N_COLON
        .xword    0

        .xword      SCSP
        .xword      LNAME
        .xword      PCREAT
        .xword      LATEST, HIDDEN
        .xword      RBRAC
        .xword      PSCOD
DOCOL:  STR     X11, [X12,#-(CW*(1))]!
        LDR     X11,[X0, #+(CW*(D_HOFFSET))]  



        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  








        .align 3
N_SEMI:
        .xword      1
        .ascii      ";"
        .align 3
SEMI:
        .xword    DOCOL
        .xword    SEMI+HEADSIZE
        .xword    B_IMMED
        .xword    COLON
        .xword    N_SEMI
        .xword    0

        .xword      QCSP
        .xword      LIT, SEMIS, COMMA
        .xword      LATEST, HIDDEN
        .xword      LBRAC
        .xword      SEMIS






        .align 3
N_LCONST:
        .xword      8
        .ascii      "CONSTANT"
        .align 3
LCONST:
        .xword    DOCOL
        .xword    LCONST+HEADSIZE
        .xword    0x0
        .xword    SEMI
        .xword    N_LCONST
        .xword    0

        .xword      LNAME
        .xword      PCREAT
        .xword      LATEST, TDFA, STOR
        .xword      PSCOD
DOCON:  LDR     X0,[X0,#+(CW*((D_HOFFSET)))] 
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_VAR:
        .xword      8
        .ascii      "VARIABLE"
        .align 3
VAR:
        .xword    DOCOL
        .xword    VAR+HEADSIZE
        .xword    0x0
        .xword    LCONST
        .xword    N_VAR
        .xword    0

        .xword      LDATA
        .xword      ZERO, COMMA
        .xword      SEMIS






        .align 3
N_LDATA:
        .xword      4
        .ascii      "DATA"
        .align 3
LDATA:
        .xword    DOCOL
        .xword    LDATA+HEADSIZE
        .xword    0x0
        .xword    VAR
        .xword    N_LDATA
        .xword    0

        .xword      LNAME
        .xword      PCREAT
        .xword      PSCOD
DOVAR:  LDR     X0,[X0,#+(CW*((D_HOFFSET)))]  
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_X:
        .xword      1
        .ascii      "_"
        .align 3
X:
        .xword    X+HEADSIZE
        .xword    X+HEADSIZE
        .xword    0x0
        .xword    LDATA
        .xword    N_X
        .xword    0

        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1   






        .align 3
N_ZERO:
        .xword      1
        .ascii      "0"
        .align 3
ZERO:
        .xword    DOCON
        .xword    0
        .xword    0x0
        .xword    X
        .xword    N_ZERO
        .xword    0








        .align 3
N_ONE:
        .xword      1
        .ascii      "1"
        .align 3
ONE:
        .xword    DOCON
        .xword    1
        .xword    0x0
        .xword    ZERO
        .xword    N_ONE
        .xword    0







        .align 3
N_TWO:
        .xword      1
        .ascii      "2"
        .align 3
TWO:
        .xword    DOCON
        .xword    2
        .xword    0x0
        .xword    ONE
        .xword    N_TWO
        .xword    0







        .align 3
N_LBL:
        .xword      2
        .ascii      "BL"
        .align 3
LBL:
        .xword    DOCON
        .xword    ABL
        .xword    0x0
        .xword    TWO
        .xword    N_LBL
        .xword    0








        .align 3
N_SFET:
        .xword      2
        .ascii      "\$@"
        .align 3
SFET:
        .xword    SFET+HEADSIZE
        .xword    SFET+HEADSIZE
        .xword    0x0
        .xword    LBL
        .xword    N_SFET
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X0, [X3],#+(CW*(1))
        MOV   X1,X3
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SSTOR:
        .xword      2
        .ascii      "\$!"
        .align 3
SSTOR:
        .xword    DOCOL
        .xword    SSTOR+HEADSIZE
        .xword    0x0
        .xword    SFET
        .xword    N_SSTOR
        .xword    0

        .xword TDUP, STOR, CELLP, SWAP, LMOVE
        .xword SEMIS








        .align 3
N_SADD:
        .xword      3
        .ascii      "\$+!"
        .align 3
SADD:
        .xword    DOCOL
        .xword    SADD+HEADSIZE
        .xword    0x0
        .xword    SSTOR
        .xword    N_SADD
        .xword    0

        .xword   LDUP, FETCH, TOR 
        .xword   TDUP, PSTOR
        .xword   CELLP, FROMR, PLUS, SWAP, LMOVE
        .xword SEMIS






        .align 3
N_CHAPP:
        .xword      3
        .ascii      "\$C+"
        .align 3
CHAPP:
        .xword    DOCOL
        .xword    CHAPP+HEADSIZE
        .xword    0x0
        .xword    SADD
        .xword    N_CHAPP
        .xword    0

        .xword   LDUP, TOR
        .xword   LDUP, FETCH, PLUS, CELLP, CSTOR
        .xword   ONE, FROMR, PSTOR
        .xword SEMIS






        .align 3
N_SCOMMA:
        .xword      2
        .ascii      "\$,"
        .align 3
SCOMMA:
        .xword    DOCOL
        .xword    SCOMMA+HEADSIZE
        .xword    0x0
        .xword    CHAPP
        .xword    N_SCOMMA
        .xword    0

        .xword HERE, TOR
        .xword LDUP, CELLP, ALLOT
        .xword RR, SSTOR, FROMR
 .xword LALIGN
        .xword SEMIS






        .align 3
N_CSLL:
        .xword      3
        .ascii      "C/L"
        .align 3
CSLL:
        .xword    DOCON
        .xword    64
        .xword    0x0
        .xword    SCOMMA
        .xword    N_CSLL
        .xword    0








        .align 3
N__FIRST:
        .xword      6
        .ascii      "_FIRST"
        .align 3
_FIRST:
        .xword    DOCON
        .xword    BUF1
        .xword    0x0
        .xword    CSLL
        .xword    N__FIRST
        .xword    0

 








        .align 3
N__LIMIT:
        .xword      6
        .ascii      "_LIMIT"
        .align 3
_LIMIT:
        .xword    DOCON
        .xword    BUF1+(KBBUF+2*CW)*NBUF
        .xword    0x0
        .xword    _FIRST
        .xword    N__LIMIT
        .xword    0







        .align 3
N_LEM:
        .xword      2
        .ascii      "EM"
        .align 3
LEM:
        .xword    DOCON
        .xword    ACTUAL_EM
        .xword    0x0
        .xword    _LIMIT
        .xword    N_LEM
        .xword    0







        .align 3
N_LBM:
        .xword      2
        .ascii      "BM"
        .align 3
LBM:
        .xword    DOCON
        .xword    _ORIG
        .xword    0x0
        .xword    LEM
        .xword    N_LBM
        .xword    0







        .align 3
N_BBUF:
        .xword      5
        .ascii      "B/BUF"
        .align 3
BBUF:
        .xword    DOCON
        .xword    KBBUF
        .xword    0x0
        .xword    LBM
        .xword    N_BBUF
        .xword    0











        .align 3
N_UZERO:
        .xword      2
        .ascii      "U0"
        .align 3
UZERO:
        .xword    DOUSE
        .xword    (CW*(1))
        .xword    0x0
        .xword    BBUF
        .xword    N_UZERO
        .xword    0







        .align 3
N_SZERO:
        .xword      2
        .ascii      "S0"
        .align 3
SZERO:
        .xword    DOUSE
        .xword    (CW*(2))
        .xword    0x0
        .xword    UZERO
        .xword    N_SZERO
        .xword    0







        .align 3
N_RZERO:
        .xword      2
        .ascii      "R0"
        .align 3
RZERO:
        .xword    DOUSE
        .xword    (CW*(3))
        .xword    0x0
        .xword    SZERO
        .xword    N_RZERO
        .xword    0







        .align 3
N_TIB:
        .xword      3
        .ascii      "TIB"
        .align 3
TIB:
        .xword    DOUSE
        .xword    (CW*(4))
        .xword    0x0
        .xword    RZERO
        .xword    N_TIB
        .xword    0







        .align 3
N_RUBOUT:
        .xword      6
        .ascii      "RUBOUT"
        .align 3
RUBOUT:
        .xword    DOUSE
        .xword    (CW*(5))
        .xword    0x0
        .xword    TIB
        .xword    N_RUBOUT
        .xword    0







        .align 3
N_LWARN:
        .xword      7
        .ascii      "WARNING"
        .align 3
LWARN:
        .xword    DOUSE
        .xword    (CW*(7))
        .xword    0x0
        .xword    RUBOUT
        .xword    N_LWARN
        .xword    0







        .align 3
N_FENCE:
        .xword      5
        .ascii      "FENCE"
        .align 3
FENCE:
        .xword    DOUSE
        .xword    (CW*(8))
        .xword    0x0
        .xword    LWARN
        .xword    N_FENCE
        .xword    0







        .align 3
N_LDP:
        .xword      2
        .ascii      "DP"
        .align 3
LDP:
        .xword    DOUSE
        .xword    (CW*(9))
        .xword    0x0
        .xword    FENCE
        .xword    N_LDP
        .xword    0







        .align 3
N_VOCL:
        .xword      8
        .ascii      "VOC-LINK"
        .align 3
VOCL:
        .xword    DOUSE
        .xword    (CW*(10))
        .xword    0x0
        .xword    LDP
        .xword    N_VOCL
        .xword    0







        .align 3
N_LOFFSET:
        .xword      6
        .ascii      "OFFSET"
        .align 3
LOFFSET:
        .xword    DOUSE
        .xword    (CW*(37))
        .xword    0x0
        .xword    VOCL
        .xword    N_LOFFSET
        .xword    0







        .align 3
N_MAXUSER:
        .xword      8
        .ascii      "MAX-USER"
        .align 3
MAXUSER:
        .xword    DOUSE
        .xword    (CW*(11))
        .xword    0x0
        .xword    LOFFSET
        .xword    N_MAXUSER
        .xword    0










        .align 3
N_LWHERE:
        .xword      5
        .ascii      "WHERE"
        .align 3
LWHERE:
        .xword    DOUSE
        .xword    (CW*(12))
        .xword    0x0
        .xword    MAXUSER
        .xword    N_LWHERE
        .xword    0
    






        .align 3
N_SCR:
        .xword      3
        .ascii      "SCR"
        .align 3
SCR:
        .xword    DOUSE
        .xword    (CW*(33))
        .xword    0x0
        .xword    LWHERE
        .xword    N_SCR
        .xword    0







        .align 3
N_STATE:
        .xword      5
        .ascii      "STATE"
        .align 3
STATE:
        .xword    DOUSE
        .xword    (CW*(18))
        .xword    0x0
        .xword    SCR
        .xword    N_STATE
        .xword    0







        .align 3
N_BASE:
        .xword      4
        .ascii      "BASE"
        .align 3
BASE:
        .xword    DOUSE
        .xword    (CW*(19))
        .xword    0x0
        .xword    STATE
        .xword    N_BASE
        .xword    0







        .align 3
N_DPL:
        .xword      3
        .ascii      "DPL"
        .align 3
DPL:
        .xword    DOUSE
        .xword    (CW*(20))
        .xword    0x0
        .xword    BASE
        .xword    N_DPL
        .xword    0







        .align 3
N_ECL:
        .xword      3
        .ascii      "ECL"
        .align 3
ECL:
        .xword    DOUSE
        .xword    (CW*(38))
        .xword    0x0
        .xword    DPL
        .xword    N_ECL
        .xword    0







        .align 3
N_LFLD:
        .xword      3
        .ascii      "FLD"
        .align 3
LFLD:
        .xword    DOUSE
        .xword    (CW*(21))
        .xword    0x0
        .xword    ECL
        .xword    N_LFLD
        .xword    0








        .align 3
N_LCSP:
        .xword      3
        .ascii      "CSP"
        .align 3
LCSP:
        .xword    DOUSE
        .xword    (CW*(22))
        .xword    0x0
        .xword    LFLD
        .xword    N_LCSP
        .xword    0








        .align 3
N_RNUM:
        .xword      2
        .ascii      "R#"
        .align 3
RNUM:
        .xword    DOUSE
        .xword    (CW*(23))
        .xword    0x0
        .xword    LCSP
        .xword    N_RNUM
        .xword    0







        .align 3
N_HLD:
        .xword      3
        .ascii      "HLD"
        .align 3
HLD:
        .xword    DOUSE
        .xword    (CW*(24))
        .xword    0x0
        .xword    RNUM
        .xword    N_HLD
        .xword    0







        .align 3
N_LOUT:
        .xword      3
        .ascii      "OUT"
        .align 3
LOUT:
        .xword    DOUSE
        .xword    (CW*(25))
        .xword    0x0
        .xword    HLD
        .xword    N_LOUT
        .xword    0







        .align 3
N_PBLK:
        .xword      5
        .ascii      "(BLK)"
        .align 3
PBLK:
        .xword    DOUSE
        .xword    (CW*(26))
        .xword    0x0
        .xword    LOUT
        .xword    N_PBLK
        .xword    0







        .align 3
N_PP:
        .xword      2
        .ascii      "PP"
        .align 3
PP:
        .xword    DOUSE
        .xword    (CW*(29))
        .xword    0x0
        .xword    PBLK
        .xword    N_PP
        .xword    0







        .align 3
N_PIIN:
        .xword      5
        .ascii      "(>IN)"
        .align 3
PIIN:
        .xword    DOUSE
        .xword    (CW*(30))
        .xword    0x0
        .xword    PP
        .xword    N_PIIN
        .xword    0







        .align 3
N_ARGS:
        .xword      4
        .ascii      "ARGS"
        .align 3
ARGS:
        .xword    DOUSE
        .xword    (CW*(31))
        .xword    0x0
        .xword    PIIN
        .xword    N_ARGS
        .xword    0







        .align 3
N_HANDLER:
        .xword      7
        .ascii      "HANDLER"
        .align 3
HANDLER:
        .xword    DOUSE
        .xword    (CW*(32))
        .xword    0x0
        .xword    ARGS
        .xword    N_HANDLER
        .xword    0







        .align 3
N_CURR:
        .xword      7
        .ascii      "CURRENT"
        .align 3
CURR:
        .xword    DOUSE
        .xword    (CW*(34))
        .xword    0x0
        .xword    HANDLER
        .xword    N_CURR
        .xword    0







        .align 3
N_REMAIND:
        .xword      9
        .ascii      "REMAINDER"
        .align 3
REMAIND:
        .xword    DOUSE
        .xword    (CW*(14))
        .xword    0x0
        .xword    CURR
        .xword    N_REMAIND
        .xword    0









        .align 3
N_CONTEXT:
        .xword      7
        .ascii      "CONTEXT"
        .align 3
CONTEXT:
        .xword    DOUSE
        .xword    (CW*(39))
        .xword    0x0
        .xword    REMAIND
        .xword    N_CONTEXT
        .xword    0
 











        .align 3
N_ONEP:
        .xword      2
        .ascii      "1+"
        .align 3
ONEP:
        .xword    DOCOL
        .xword    ONEP+HEADSIZE
        .xword    0x0
        .xword    CONTEXT
        .xword    N_ONEP
        .xword    0

        .xword      ONE
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_CELLP:
        .xword      5
        .ascii      "CELL+"
        .align 3
CELLP:
        .xword    DOCOL
        .xword    CELLP+HEADSIZE
        .xword    0x0
        .xword    ONEP
        .xword    N_CELLP
        .xword    0

        .xword      LIT, CW
        .xword      PLUS
        .xword      SEMIS







        .align 3
N_LCELLS:
        .xword      5
        .ascii      "CELLS"
        .align 3
LCELLS:
        .xword    DOCOL
        .xword    LCELLS+HEADSIZE
        .xword    0x0
        .xword    CELLP
        .xword    N_LCELLS
        .xword    0

        .xword        LIT, 3
        .xword      LSHIFT
        .xword      SEMIS






        .align 3
N_CHARP:
        .xword      5
        .ascii      "CHAR+"
        .align 3
CHARP:
        .xword    DOCOL
        .xword    (ONEP+HEADSIZE)
        .xword    0x0
        .xword    LCELLS
        .xword    N_CHARP
        .xword    0







        .align 3
N_CHARS:
        .xword      5
        .ascii      "CHARS"
        .align 3
CHARS:
        .xword    DOCOL 
        .xword    CHARS+HEADSIZE
        .xword    0x0
        .xword    CHARP
        .xword    N_CHARS
        .xword    0

        .xword      SEMIS






        .align 3
N_LALIGN:
        .xword      5
        .ascii      "ALIGN"
        .align 3
LALIGN:
        .xword    DOCOL 
        .xword    LALIGN+HEADSIZE
        .xword    0x0
        .xword    CHARS
        .xword    N_LALIGN
        .xword    0


        .xword      LDP, FETCH
        .xword      ALIGNED
        .xword      LDP, STOR

        .xword      SEMIS






        .align 3
N_ALIGNED :
        .xword      7
        .ascii      "ALIGNED"
        .align 3
ALIGNED :
        .xword    ALIGNED +HEADSIZE
        .xword    ALIGNED +HEADSIZE
        .xword    0x0
        .xword    LALIGN
        .xword    N_ALIGNED 
        .xword    0


        LDR     X0, [X13],#+(CW*(1))
        SUB     X0,X0, #1
        
        ORR     X0, X0, #(CW-1) 
        ADD     X0,X0, #1
        STR     X0, [X13,#-(CW*(1))]!

        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_HERE:
        .xword      4
        .ascii      "HERE"
        .align 3
HERE:
        .xword    DOCOL
        .xword    HERE+HEADSIZE
        .xword    0x0
        .xword    ALIGNED 
        .xword    N_HERE
        .xword    0

        .xword      LDP
        .xword      FETCH
        .xword      SEMIS






        .align 3
N_ALLOT:
        .xword      5
        .ascii      "ALLOT"
        .align 3
ALLOT:
        .xword    DOCOL
        .xword    ALLOT+HEADSIZE
        .xword    0x0
        .xword    HERE
        .xword    N_ALLOT
        .xword    0

        .xword      LDP
        .xword      PSTOR
        .xword      SEMIS






        .align 3
N_COMMA:
        .xword      1
        .ascii      ","
        .align 3
COMMA:
        .xword    DOCOL
        .xword    COMMA+HEADSIZE
        .xword    0x0
        .xword    ALLOT
        .xword    N_COMMA
        .xword    0

        .xword      HERE
        .xword      LIT
        .xword      CW
        .xword      ALLOT
        .xword      STOR
        .xword      SEMIS






        .align 3
N_CCOMM:
        .xword      2
        .ascii      "C,"
        .align 3
CCOMM:
        .xword    DOCOL
        .xword    CCOMM+HEADSIZE
        .xword    0x0
        .xword    COMMA
        .xword    N_CCOMM
        .xword    0

        .xword      HERE
        .xword      ONE
        .xword      ALLOT
        .xword      CSTOR
        .xword      SEMIS






        .align 3
N_TCOMM:
        .xword      2
        .ascii      "2,"
        .align 3
TCOMM:
        .xword    DOCOL
        .xword    TCOMM+HEADSIZE
        .xword    0x0
        .xword    CCOMM
        .xword    N_TCOMM
        .xword    0

        .xword      HERE
        .xword      LIT
        .xword      CW*2
        .xword      ALLOT
        .xword      TSTOR
        .xword      SEMIS






        .align 3
N_LSUB:
        .xword      1
        .ascii      "-"
        .align 3
LSUB:
        .xword    LSUB+HEADSIZE
        .xword    LSUB+HEADSIZE
        .xword    0x0
        .xword    TCOMM
        .xword    N_LSUB
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))
        SUB     X0,X0,X1
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1     






        .align 3
N_EQUAL:
        .xword      1
        .ascii      "="
        .align 3
EQUAL:
        .xword    DOCOL
        .xword    EQUAL+HEADSIZE
        .xword    0x0
        .xword    LSUB
        .xword    N_EQUAL
        .xword    0

        .xword      LSUB
        .xword      ZEQU
        .xword      SEMIS






        .align 3
N_LESS:
        .xword      1
        .ascii      "<"
        .align 3
LESS:
        .xword    LESS+HEADSIZE
        .xword    LESS+HEADSIZE
        .xword    0x0
        .xword    EQUAL
        .xword    N_LESS
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        MOV    X0, #0   
        CMP     X3,X1
        BGE     LES1
        SUB     X0,X0, #1
LES1:   STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_ULESS:
        .xword      2
        .ascii      "U<"
        .align 3
ULESS:
        .xword    ULESS+HEADSIZE
        .xword    ULESS+HEADSIZE
        .xword    0x0
        .xword    LESS
        .xword    N_ULESS
        .xword    0

        LDR     X0, [X13],#+(CW*(1))
        LDR     X1, [X13],#+(CW*(1))
        SUBS    X1,X1,X0
        SBC     X0,X0,X0
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_GREAT:
        .xword      1
        .ascii      ">"
        .align 3
GREAT:
        .xword    DOCOL
        .xword    GREAT+HEADSIZE
        .xword    0x0
        .xword    ULESS
        .xword    N_GREAT
        .xword    0

        .xword      SWAP
        .xword      LESS
        .xword      SEMIS






        .align 3
N_UNEQ:
        .xword      2
        .ascii      "<>"
        .align 3
UNEQ:
        .xword    DOCOL
        .xword    UNEQ+HEADSIZE
        .xword    0x0
        .xword    GREAT
        .xword    N_UNEQ
        .xword    0

        .xword      LSUB
        .xword      ZEQU
        .xword      ZEQU
        .xword      SEMIS






        .align 3
N_ROT:
        .xword      3
        .ascii      "ROT"
        .align 3
ROT:
        .xword    ROT+HEADSIZE
        .xword    ROT+HEADSIZE
        .xword    0x0
        .xword    UNEQ
        .xword    N_ROT
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X3, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      
        STR     X3, [X13,#-(CW*(1))]!
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SPACE:
        .xword      5
        .ascii      "SPACE"
        .align 3
SPACE:
        .xword    DOCOL
        .xword    SPACE+HEADSIZE
        .xword    0x0
        .xword    ROT
        .xword    N_SPACE
        .xword    0

        .xword      LBL
        .xword      EMIT
        .xword      SEMIS






        .align 3
N_QDUP:
        .xword      4
        .ascii      "?DUP"
        .align 3
QDUP:
        .xword    DOCOL
        .xword    QDUP+HEADSIZE
        .xword    0x0
        .xword    SPACE
        .xword    N_QDUP
        .xword    0

        .xword      LDUP
        .xword      ZBRAN
        .xword      QDUP1-.-CW 
        .xword      LDUP    
QDUP1:  .xword      SEMIS






        .align 3
N_LATEST:
        .xword      6
        .ascii      "LATEST"
        .align 3
LATEST:
        .xword    DOCOL
        .xword    LATEST+HEADSIZE
        .xword    0x0
        .xword    QDUP
        .xword    N_LATEST
        .xword    0

        .xword      CURR
        .xword      FETCH
        .xword      TLFA
        .xword      FETCH
        .xword      SEMIS






        .align 3
N_TCFA:
        .xword      4
        .ascii      ">CFA"
        .align 3
TCFA:
        .xword    DOCOL
        .xword    TCFA+HEADSIZE
        .xword    0x0
        .xword    LATEST
        .xword    N_TCFA
        .xword    0

        .xword      LIT, (CW*(C_HOFFSET))
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_TDFA:
        .xword      4
        .ascii      ">DFA"
        .align 3
TDFA:
        .xword    DOCOL
        .xword    TDFA+HEADSIZE
        .xword    0x0
        .xword    TCFA
        .xword    N_TDFA
        .xword    0

        .xword      LIT, (CW*(D_HOFFSET))
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_TFFA:
        .xword      4
        .ascii      ">FFA"
        .align 3
TFFA:
        .xword    DOCOL
        .xword    TFFA+HEADSIZE
        .xword    0x0
        .xword    TDFA
        .xword    N_TFFA
        .xword    0

        .xword      LIT, (CW*(F_HOFFSET))
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_TLFA:
        .xword      4
        .ascii      ">LFA"
        .align 3
TLFA:
        .xword    DOCOL
        .xword    TLFA+HEADSIZE
        .xword    0x0
        .xword    TFFA
        .xword    N_TLFA
        .xword    0

        .xword      LIT, (CW*(L_HOFFSET))
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_TNFA:
        .xword      4
        .ascii      ">NFA"
        .align 3
TNFA:
        .xword    DOCOL
        .xword    TNFA+HEADSIZE
        .xword    0x0
        .xword    TLFA
        .xword    N_TNFA
        .xword    0

        .xword      LIT,(CW*(N_HOFFSET))
        .xword      PLUS
        .xword      SEMIS








        .align 3
N_TSFA:
        .xword      4
        .ascii      ">SFA"
        .align 3
TSFA:
        .xword    DOCOL
        .xword    TSFA+HEADSIZE
        .xword    0x0
        .xword    TNFA
        .xword    N_TSFA
        .xword    0

        .xword      LIT,(CW*(S_HOFFSET))
        .xword      PLUS
        .xword      SEMIS








        .align 3
N_TPHA:
        .xword      4
        .ascii      ">PHA"
        .align 3
TPHA:
        .xword    DOCOL
        .xword    TPHA+HEADSIZE
        .xword    0x0
        .xword    TSFA
        .xword    N_TPHA
        .xword    0

        .xword      LIT,(CW*(PH_OFFSET))
        .xword      PLUS
        .xword      SEMIS






        .align 3
N_TOBODY:
        .xword      5
        .ascii      ">BODY"
        .align 3
TOBODY:
        .xword    DOCOL
        .xword    TOBODY+HEADSIZE
        .xword    0x0
        .xword    TPHA
        .xword    N_TOBODY
        .xword    0

        .xword      TDFA, FETCH
        .xword      CELLP           
        .xword      SEMIS






        .align 3
N_BODYF:
        .xword      5
        .ascii      "BODY>"
        .align 3
BODYF:
        .xword    DOCOL
        .xword    BODYF+HEADSIZE
        .xword    0x0
        .xword    TOBODY
        .xword    N_BODYF
        .xword    0

        .xword      LIT,(CW*(BD_OFFSET))
        .xword      LSUB
        .xword      SEMIS






        .align 3
N_TWID:
        .xword      4
        .ascii      ">WID"
        .align 3
TWID:
        .xword    DOCOL
        .xword    TWID+HEADSIZE
        .xword    0x0
        .xword    BODYF
        .xword    N_TWID
        .xword    0

        .xword      TOBODY
        .xword      CELLP 
        .xword      SEMIS






        .align 3
N_TVFA:
        .xword      4
        .ascii      ">VFA"
        .align 3
TVFA:
        .xword    DOCOL
        .xword    TVFA+HEADSIZE
        .xword    0x0
        .xword    TWID
        .xword    N_TVFA
        .xword    0

        .xword      TOBODY
        .xword      SEMIS







        .align 3
N_SCSP:
        .xword      4
        .ascii      "!CSP"
        .align 3
SCSP:
        .xword    DOCOL
        .xword    SCSP+HEADSIZE
        .xword    0x0
        .xword    TVFA
        .xword    N_SCSP
        .xword    0

        .xword      SPFET
        .xword      LCSP
        .xword      STOR
        .xword      SEMIS







        .align 3
N_QERR:
        .xword      6
        .ascii      "?ERROR"
        .align 3
QERR:
        .xword    DOCOL
        .xword    QERR+HEADSIZE
        .xword    0x0
        .xword    SCSP
        .xword    N_QERR
        .xword    0

        .xword      SWAP
        .xword      ZBRAN
        .xword      QERR1-.-CW 
        .xword      PP, FETCH
        .xword      SRC, FETCH
        .xword      LWHERE, TSTOR
        .xword      THROW
        .xword      BRAN
        .xword      QERR2-.-CW  
QERR1:  .xword      DROP    
QERR2:  .xword      SEMIS






        .align 3
N_QERRUR:
        .xword      6
        .ascii      "?ERRUR"
        .align 3
QERRUR:
        .xword    DOCOL
        .xword    QERRUR+HEADSIZE
        .xword    0x0
        .xword    QERR
        .xword    N_QERRUR
        .xword    0

        .xword      ZERO, MIN, LDUP, QERR
        .xword      SEMIS







        .align 3
N_QDELIM:
        .xword      6
        .ascii      "?DELIM"
        .align 3
QDELIM:
        .xword    DOCOL
        .xword    QDELIM+HEADSIZE
        .xword    0x0
        .xword    QERRUR
        .xword    N_QDELIM
        .xword    0

        .xword      PPFET
        .xword      QBL
        .xword      ZEQU
        .xword      LIT, 10, QERR
        .xword      DROP
        .xword      SEMIS






        .align 3
N_QCSP:
        .xword      4
        .ascii      "?CSP"
        .align 3
QCSP:
        .xword    DOCOL
        .xword    QCSP+HEADSIZE
        .xword    0x0
        .xword    QDELIM
        .xword    N_QCSP
        .xword    0

        .xword      SPFET
        .xword      LCSP
        .xword      FETCH
        .xword      LSUB
        .xword      LIT, 20, QERR
        .xword      SEMIS






        .align 3
N_QCOMP:
        .xword      5
        .ascii      "?COMP"
        .align 3
QCOMP:
        .xword    DOCOL
        .xword    QCOMP+HEADSIZE
        .xword    0x0
        .xword    QCSP
        .xword    N_QCOMP
        .xword    0

        .xword      STATE
        .xword      FETCH
        .xword      ZEQU
        .xword      LIT, 17, QERR
        .xword      SEMIS








        .align 3
N_QPAIR:
        .xword      6
        .ascii      "?PAIRS"
        .align 3
QPAIR:
        .xword    DOCOL
        .xword    QPAIR+HEADSIZE
        .xword    0x0
        .xword    QCOMP
        .xword    N_QPAIR
        .xword    0

        .xword      LSUB
        .xword      LIT, 19, QERR
        .xword      SEMIS











        .align 3
N_LBRAC:
        .xword      1
        .ascii      "["
        .align 3
LBRAC:
        .xword    DOCOL
        .xword    LBRAC+HEADSIZE
        .xword    B_IMMED
        .xword    QPAIR
        .xword    N_LBRAC
        .xword    0

        .xword      ZERO
        .xword      STATE
        .xword      STOR
        .xword      SEMIS






        .align 3
N_RBRAC:
        .xword      1
        .ascii      "]"
        .align 3
RBRAC:
        .xword    DOCOL
        .xword    RBRAC+HEADSIZE
        .xword    0x0
        .xword    LBRAC
        .xword    N_RBRAC
        .xword    0

        .xword      ONE
        .xword      STATE
        .xword      STOR
        .xword      SEMIS






        .align 3
N_HIDDEN:
        .xword      6
        .ascii      "HIDDEN"
        .align 3
HIDDEN:
        .xword    DOCOL
        .xword    HIDDEN+HEADSIZE
        .xword    0x0
        .xword    RBRAC
        .xword    N_HIDDEN
        .xword    0

        .xword      TFFA
        .xword      LIT,B_INVIS
        .xword      TOGGL
        .xword      SEMIS






        .align 3
N_HEX:
        .xword      3
        .ascii      "HEX"
        .align 3
HEX:
        .xword    DOCOL
        .xword    HEX+HEADSIZE
        .xword    0x0
        .xword    HIDDEN
        .xword    N_HEX
        .xword    0

        .xword      LIT,16
        .xword      BASE
        .xword      STOR
        .xword      SEMIS






        .align 3
N_DECA:
        .xword      7
        .ascii      "DECIMAL"
        .align 3
DECA:
        .xword    DOCOL
        .xword    DECA+HEADSIZE
        .xword    0x0
        .xword    HEX
        .xword    N_DECA
        .xword    0

        .xword      LIT,10
        .xword      BASE
        .xword      STOR
        .xword      SEMIS






        .align 3
N_PSCOD:
        .xword      7
        .ascii      "(;CODE)"
        .align 3
PSCOD:
        .xword    DOCOL
        .xword    PSCOD+HEADSIZE
        .xword    0x0
        .xword    DECA
        .xword    N_PSCOD
        .xword    0

        .xword      FROMR
        .xword      LATEST
        .xword      TCFA
        .xword      STOR
        .xword      SEMIS








        .align 3
N_LCREATE:
        .xword      6
        .ascii      "CREATE"
        .align 3
LCREATE:
        .xword    DOCOL
        .xword    LCREATE+HEADSIZE
        .xword    0x0
        .xword    PSCOD
        .xword    N_LCREATE
        .xword    0

        .xword      LNAME
        .xword      PCREAT
        .xword      LIT, HLNOOP, COMMA
        .xword      PSCOD
DODOE:  STR     X11, [X12,#-(CW*(1))]!
        LDR     X11,[X0,#+(CW*((D_HOFFSET)))] 
        MOV     X0, X11
        ADD     X0,X0,#(CW*(1))
        LDR     X11,[X11]
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  
HLNOOP: .xword      SEMIS






        .align 3
N_DOES:
        .xword      5
        .ascii      "DOES>"
        .align 3
DOES:
        .xword    DOCOL
        .xword    DOES+HEADSIZE
        .xword    0x0
        .xword    LCREATE
        .xword    N_DOES
        .xword    0

        .xword      FROMR
        .xword      LATEST
        .xword      TDFA
        .xword      FETCH
        .xword      STOR
        .xword      SEMIS






        .align 3
N_COUNT:
        .xword      5
        .ascii      "COUNT"
        .align 3
COUNT:
        .xword    DOCOL
        .xword    COUNT+HEADSIZE
        .xword    0x0
        .xword    DOES
        .xword    N_COUNT
        .xword    0

        .xword      LDUP
        .xword      ONEP
        .xword      SWAP
        .xword      CFET
        .xword      SEMIS






        .align 3
N_DTRAI:
        .xword      9
        .ascii      "-TRAILING"
        .align 3
DTRAI:
        .xword    DOCOL
        .xword    DTRAI+HEADSIZE
        .xword    0x0
        .xword    COUNT
        .xword    N_DTRAI
        .xword    0

        .xword      LDUP
        .xword      ZERO
        .xword     XQDO
        .xword      DTRA4-.-CW
DTRA1:  .xword      OVER
        .xword      OVER
        .xword      PLUS
        .xword      ONE
        .xword      LSUB
        .xword      CFET
        .xword      QBL
        .xword      ZEQU
        .xword      ZBRAN
        .xword      DTRA2-.-CW 
        .xword      LLEAV
DTRA2:  .xword      ONE
        .xword      LSUB    
        .xword     ONE, XPLOOP, ZBRAN
        .xword      DTRA1-.-CW
	.xword      UNLOOP    
DTRA4:
        .xword      SEMIS






        .align 3
N_SQUOT:
        .xword      2
        .ascii      "S\""
        .align 3
SQUOT:
        .xword    DOCOL
        .xword    SQUOT+HEADSIZE
        .xword    B_IMMED
        .xword    DTRAI
        .xword    N_SQUOT
        .xword    0

        .xword      DENQ
        .xword      SEMIS






        .align 3
N_DOTQ:
        .xword      2
        .ascii      ".\""
        .align 3
DOTQ:
        .xword    DOCOL
        .xword    DOTQ+HEADSIZE
        .xword    B_IMMED
        .xword    SQUOT
        .xword    N_DOTQ
        .xword    0

        .xword      DENQ
        .xword      STATE
        .xword      FETCH
        .xword      ZBRAN
        .xword      DOTQ1-.-CW 
        .xword      LIT, LTYPE, COMMA
        .xword      BRAN
        .xword      DOTQ2-.-CW
DOTQ1:
        .xword      LTYPE
DOTQ2:
        .xword      SEMIS   






        .align 3
N_DOTP:
        .xword      2
        .ascii      ".("
        .align 3
DOTP:
        .xword    DOCOL
        .xword    DOTP+HEADSIZE
        .xword    B_IMMED
        .xword    DOTQ
        .xword    N_DOTP
        .xword    0

        .xword      LIT, ')'
        .xword      PARSE
        .xword      LTYPE
        .xword      SEMIS






        .align 3
N_SETSRC:
        .xword      7
        .ascii      "SET-SRC"
        .align 3
SETSRC:
        .xword    DOCOL
        .xword    SETSRC+HEADSIZE
        .xword    0x0
        .xword    DOTP
        .xword    N_SETSRC
        .xword    0

        .xword      OVER, PLUS
        .xword      OVER, SRC, TSTOR
        .xword      PP, STOR 


        .xword      SEMIS






        .align 3
N_EVALUATE:
        .xword      8
        .ascii      "EVALUATE"
        .align 3
EVALUATE:
        .xword    DOCOL
        .xword    EVALUATE+HEADSIZE
        .xword    0x0
        .xword    SETSRC
        .xword    N_EVALUATE
        .xword    0

        .xword      SAVE
        .xword      SETSRC
        .xword      LIT, INTER, CATCH
        .xword      RESTO
        .xword      THROW
        .xword      SEMIS






        .align 3
N_FILL:
        .xword      4
        .ascii      "FILL"
        .align 3
FILL:
        .xword    FILL+HEADSIZE
        .xword    FILL+HEADSIZE
        .xword    0x0
        .xword    EVALUATE
        .xword    N_FILL
        .xword    0

        LDR     X0, [X13],#+(CW*(1))      
        LDR     X2, [X13],#+(CW*(1))      
        LDR     X1, [X13],#+(CW*(1))      
        ANDS X2,X2, X2
        BEQ FILL2    
FILL1:  STRB    W0, [X1],#+1
        SUBS  X2,X2,#1
        BNE FILL1
FILL2:  LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_CORA:
        .xword      4
        .ascii      "CORA"
        .align 3
CORA:
        .xword    CORA+HEADSIZE
        .xword    CORA+HEADSIZE
        .xword    0x0
        .xword    FILL
        .xword    N_CORA
        .xword    0

        
        MOV    X0,#0   
        LDR     X3, [X13],#+(CW*(1))      
        LDR     X4, [X13],#+(CW*(1))      
        LDR     X5, [X13],#+(CW*(1))      
        MOV     X1,#0
        MOV     X2,#0
CORA1:
        SUBS     X3,X3,#1
        BMI      CORA3        
        LDRB    W1, [X5],#+1          
        LDRB    W2, [X4],#+1          
        CMP      W1,W2
        BEQ      CORA1        
        MOV     X0, #1
        BHI      CORA3        
        
        MOV    X0,#-1  
CORA3:
        
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SINDEX:
        .xword      2
        .ascii      "\$^"
        .align 3
SINDEX:
        .xword    SINDEX+HEADSIZE
        .xword    SINDEX+HEADSIZE
        .xword    0x0
        .xword    CORA
        .xword    N_SINDEX
        .xword    0


        LDR     X0, [X13],#+(CW*(1))      
        LDR     X2, [X13],#+(CW*(1))      
        LDR     X4, [X13],#+(CW*(1))      
        BICS    X1,X1,X1    
SINDEX1:
        ANDS    X2,X2,X2
        BEQ     SINDEX3
        LDRB    W1, [X4],#+1         
        CMP     W0,W1       
        BEQ     SINDEX2
        SUB     X2,X2,#1
        B     SINDEX1
SINDEX3:
        MOV    X4,#0       
        ADD     X4,X4, #1
SINDEX2:
        SUB     X4,X4, #1
        STR     X4, [X13,#-(CW*(1))]!            
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_SSLAS:
        .xword      2
        .ascii      "\$/"
        .align 3
SSLAS:
        .xword    SSLAS+HEADSIZE
        .xword    SSLAS+HEADSIZE
        .xword    0x0
        .xword    SINDEX
        .xword    N_SSLAS
        .xword    0

        
        LDR     X0, [X13],#+(CW*(1))          
        LDR     X2, [X13],#+(CW*(1))          
        MOV     X5,X2
        LDR     X4, [X13],#+(CW*(1))          
        MOV     X1,X4   
        ANDS    X4,X4,X4    
        BEQ     SSLAS3   
SSLAS1:
        LDRB    W3, [X4],#+1         
        CMP     W0, W3
        BEQ     SSLAS2
        SUBS    X2,X2, #1
        BNE     SSLAS1


        STR     X2, [X13,#-(CW*(1))]!    
        B     SSLAS4
SSLAS2:
        SUB     X5,X5,X2
        SUB     X2,X2,#1 
SSLAS3:
        STR     X4, [X13,#-(CW*(1))]!
SSLAS4:
        STR     X2, [X13,#-(CW*(1))]!   
        STR     X1, [X13,#-(CW*(1))]!   
        STR     X5, [X13,#-(CW*(1))]!   
        
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  





        .align 3
N_BSLAS:
        .xword      2
        .ascii      "\$\\"
        .align 3
BSLAS:
        .xword    BSLAS+HEADSIZE
        .xword    BSLAS+HEADSIZE
        .xword    0x0
        .xword    SSLAS
        .xword    N_BSLAS
        .xword    0
   
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  





        .align 3
N_LERASE:
        .xword      5
        .ascii      "ERASE"
        .align 3
LERASE:
        .xword    DOCOL
        .xword    LERASE+HEADSIZE
        .xword    0x0
        .xword    BSLAS
        .xword    N_LERASE
        .xword    0

        .xword      ZERO
        .xword      FILL
        .xword      SEMIS






        .align 3
N_BLANK:
        .xword      5
        .ascii      "BLANK"
        .align 3
BLANK:
        .xword    DOCOL
        .xword    BLANK+HEADSIZE
        .xword    0x0
        .xword    LERASE
        .xword    N_BLANK
        .xword    0

        .xword      LBL
        .xword      FILL
        .xword      SEMIS






        .align 3
N_HOLD:
        .xword      4
        .ascii      "HOLD"
        .align 3
HOLD:
        .xword    DOCOL
        .xword    HOLD+HEADSIZE
        .xword    0x0
        .xword    BLANK
        .xword    N_HOLD
        .xword    0

        .xword      LIT,-1
        .xword      HLD
        .xword      PSTOR
        .xword      HLD
        .xword      FETCH
        .xword      CSTOR
        .xword      SEMIS






        .align 3
N_PAD:
        .xword      3
        .ascii      "PAD"
        .align 3
PAD:
        .xword    DOCOL
        .xword    PAD+HEADSIZE
        .xword    0x0
        .xword    HOLD
        .xword    N_PAD
        .xword    0

        .xword      HERE

        .xword      LIT,84+128+64
        .xword      PLUS
        .xword      SEMIS









        .align 3
N_LCHAR:
        .xword      4
        .ascii      "CHAR"
        .align 3
LCHAR:
        .xword    DOCOL
        .xword    LCHAR+HEADSIZE
        .xword    0x0
        .xword    PAD
        .xword    N_LCHAR
        .xword    0

        .xword      LNAME, DROP, CFET
        .xword      SEMIS






        .align 3
N_BCHAR:
        .xword      6
        .ascii      "[CHAR]"
        .align 3
BCHAR:
        .xword    DOCOL
        .xword    BCHAR+HEADSIZE
        .xword    B_IMMED
        .xword    LCHAR
        .xword    N_BCHAR
        .xword    0

        .xword      LCHAR, LITER
        .xword      SEMIS






        .align 3
N_PNUMB:
        .xword      8
        .ascii      "(NUMBER)"
        .align 3
PNUMB:
        .xword    DOCOL
        .xword    PNUMB+HEADSIZE
        .xword    0x0
        .xword    BCHAR
        .xword    N_PNUMB
        .xword    0

        .xword      ZERO, ZERO
        .xword      ZERO, DPL, STOR
NPNUM1:  .xword      PPFET   
        .xword      LDUP, LIT, ADOT, EQUAL
        .xword      ZBRAN
        .xword      NPNUM2-.-CW 
        .xword      DROP, DPL, STOR
        .xword      BRAN
        .xword      NPNUM1-.-CW 
NPNUM2:
        .xword      LDUP, LIT, ',', EQUAL
        .xword      ZBRAN
        .xword      NPNUM3-.-CW 
        .xword      TDROP
        .xword      BRAN
        .xword      NPNUM1-.-CW 
NPNUM3:
        .xword      LDUP, QBL, ZEQU
        .xword      ZBRAN
        .xword      NPNUM5-.-CW  
        .xword      NIP
        .xword      BASE, FETCH, DIGIT
        .xword      ZEQU
        .xword      LIT, 10, QERR

        .xword      SWAP
        .xword      BASE
        .xword      FETCH
        .xword      USTAR
        .xword      DROP
        .xword      ROT
        .xword      BASE
        .xword      FETCH
        .xword      USTAR
        .xword      DPLUS
        .xword      BRAN
        .xword      NPNUM1-.-CW 
NPNUM5:
        .xword      DROP, PP, STOR
        .xword      SEMIS






        .align 3
N_NUMB:
        .xword      6
        .ascii      "NUMBER"
        .align 3
NUMB:
        .xword    DOCOL
        .xword    NUMB+HEADSIZE
        .xword    0x0
        .xword    PNUMB
        .xword    N_NUMB
        .xword    0

LNUMB:
        .xword      LIT, -1, PP, PSTOR
        .xword      PNUMB, SDLITE
        .xword      SEMIS






        .align 3
N_TONUMB:
        .xword      7
        .ascii      ">NUMBER"
        .align 3
TONUMB:
        .xword    DOCOL
        .xword    TONUMB+HEADSIZE
        .xword    0x0
        .xword    NUMB
        .xword    N_TONUMB
        .xword    0

        .xword      TDUP, PLUS, TOR     
        .xword      ZERO
        .xword     XQDO
        .xword      TONUM9-.-CW
TONUM1:
        .xword      LDUP, CFET, BASE, FETCH, DIGIT
        .xword      ZEQU
        .xword      ZBRAN
        .xword      TONUM4-.-CW 
        .xword      DROP
        .xword      LLEAV
TONUM4:
        .xword      SWAP, TOR 
        .xword      SWAP
        .xword      BASE
        .xword      FETCH
        .xword      USTAR
        .xword      DROP
        .xword      ROT
        .xword      BASE
        .xword      FETCH
        .xword      USTAR
        .xword      DPLUS
        .xword      FROMR, ONEP     
        .xword     ONE, XPLOOP, ZBRAN
        .xword      TONUM1-.-CW
	.xword      UNLOOP
TONUM9:
        .xword      FROMR
        .xword      OVER, LSUB
        .xword      SEMIS






        .align 3
N_FOUND:
        .xword      5
        .ascii      "FOUND"
        .align 3
FOUND:
        .xword    DOCOL
        .xword    FOUND+HEADSIZE
        .xword    0x0
        .xword    TONUMB
        .xword    N_FOUND
        .xword    0

        .xword      CONTEXT, TOR
FOUND1: .xword      RR, FETCH

        .xword      PFIND, LDUP, ZEQU
        .xword      ZBRAN
        .xword      FOUND3-.-CW
        .xword      DROP
        .xword      RR, FETCH, LIT, ONLYBODY, LSUB 
        .xword      ZBRAN
        .xword      FOUND2-.-CW
        .xword      FROMR, CELLP, TOR
        .xword      BRAN
        .xword      FOUND1-.-CW
FOUND2: .xword      ZERO
FOUND3: .xword      RDROP
        .xword      NIP,NIP
        .xword      SEMIS






        .align 3
N_PRESENT:
        .xword      7
        .ascii      "PRESENT"
        .align 3
PRESENT:
        .xword    DOCOL
        .xword    PRESENT+HEADSIZE
        .xword    0x0
        .xword    FOUND
        .xword    N_PRESENT
        .xword    0

        .xword      LDUP, TOR
        .xword      FOUND
        .xword      LDUP
        .xword      ZBRAN
        .xword      PRES1-.-CW
        .xword      LDUP
        .xword      TNFA, FETCH, FETCH 
        .xword      RR, EQUAL
        .xword      LAND
PRES1:
        .xword      RDROP
        .xword      SEMIS












        .align 3
N_PFIND:
        .xword      6
        .ascii      "(FIND)"
        .align 3
PFIND:
        .xword    DOCOL
        .xword    PFIND+HEADSIZE
        .xword    0x0
        .xword    PRESENT
        .xword    N_PFIND
        .xword    0









PFIND0:                       
         .xword      NMATCH
         .xword      ZEQU
        .xword      ZBRAN
        .xword      PFCONTINUE-.-CW

        .xword      TDUP, TNFA, FETCH, FETCH
        .xword      EQUAL 

        .xword      OVER, TFFA, FETCH
        .xword      LIT, B_DENOT, LAND
        .xword      LOR             
        .xword      ZBRAN
        .xword      PFCONTINUE-.-CW

        .xword      LDUP, TFFA, FETCH
        .xword      LIT, B_INVIS | B_DUMMY, LAND
        .xword      ZEQU
        .xword      ZBRAN
        .xword      PFCONTINUE-.-CW
        .xword      BRAN
        .xword      PFEXIT-.-CW		
PFCONTINUE:
        .xword	TLFA, FETCH
        .xword      LDUP, ZEQU
        .xword      ZBRAN
        .xword      PFIND0-.-CW
PFEXIT:   
        .xword      SEMIS






        .align 3
N_LERROR:
        .xword      5
        .ascii      "ERROR"
        .align 3
LERROR:
        .xword    DOCOL
        .xword    LERROR+HEADSIZE
        .xword    0x0
        .xword    PFIND
        .xword    N_LERROR
        .xword    0


        .xword      LWHERE, TFET
        .xword      OVER
        .xword      ZBRAN
        .xword      ERR2-.-CW      
        .xword      OVER, LIT, 20, LSUB
        .xword      MAX
        .xword      SWAP
        .xword      ONEM         
ERR1:   .xword      LDUP, CFET, QBL, ZEQU  
        .xword      ZBRAN
        .xword      ERR2 -.-CW
        .xword      ONEP
        .xword      BRAN
        .xword      ERR1 -.-CW
ERR2:
        .xword      OVER, LSUB
        .xword      ETYPE
        .xword      SKIP
         .xword      19
SB1: .ascii      " ? ciforth ERROR # "
       .align 3
        .xword      LIT, SB1
        .xword      LIT, 19
        .xword      ETYPE
        .xword      BASE, FETCH
        .xword      DECA
        .xword      OVER
        .xword      STOD, ZERO, PDDOTR      
        .xword      ETYPE
        .xword      BASE, STOR
        .xword      LIT, -256, MAX
        .xword      LIT, 63, MIN
        .xword      LIT, MESS, CATCH, DROP  
        .xword      SEMIS






        .align 3
N_CATCH:
        .xword      5
        .ascii      "CATCH"
        .align 3
CATCH:
        .xword    DOCOL
        .xword    CATCH+HEADSIZE
        .xword    0x0
        .xword    LERROR
        .xword    N_CATCH
        .xword    0

        .xword      SPFET, CELLP, TOR
        .xword      HANDLER, FETCH, TOR
        .xword      RPFET, HANDLER, STOR
        .xword      EXEC
        .xword      FROMR, HANDLER, STOR
        .xword      RDROP, ZERO
        .xword      SEMIS






        .align 3
N_THROW:
        .xword      5
        .ascii      "THROW"
        .align 3
THROW:
        .xword    DOCOL
        .xword    THROW+HEADSIZE
        .xword    0x0
        .xword    CATCH
        .xword    N_THROW
        .xword    0

        .xword      LDUP
        .xword      ZBRAN
        .xword      THROW1-.-CW
        .xword      HANDLER, FETCH, ZEQU
        .xword      ZBRAN
        .xword      THROW2-.-CW
        .xword      LERROR
        .xword      CLS
        .xword      QUIT
THROW2:
        .xword      HANDLER, FETCH, RPSTO
        .xword      FROMR, HANDLER, STOR
        .xword      FROMR, SWAP, TOR
        .xword      SPSTO
        .xword      FROMR
        .xword      X
THROW1:
        .xword      DROP
        .xword      SEMIS











        .align 3
N_IDDOT:
        .xword      3
        .ascii      "ID."
        .align 3
IDDOT:
        .xword    DOCOL
        .xword    IDDOT+HEADSIZE
        .xword    0x0
        .xword    THROW
        .xword    N_IDDOT
        .xword    0

        .xword      LDUP, TFFA, FETCH
        .xword      LIT, B_DUMMY, LAND
        .xword      ZBRAN
        .xword      IDDOT1-.-CW
        .xword      DROP
        .xword      BRAN
        .xword      IDDOT2-.-CW
IDDOT1:
        .xword      TNFA
        .xword      FETCH
        .xword      SFET
        .xword      LTYPE
        .xword      SPACE
        .xword      SPACE
        .xword      SPACE
IDDOT2:
        .xword      SEMIS






        .align 3
N_LHEAD:
        .xword      6
        .ascii      "HEADER"
        .align 3
LHEAD:
        .xword    DOCOL
        .xword    LHEAD+HEADSIZE
        .xword    0x0
        .xword    IDDOT
        .xword    N_LHEAD
        .xword    0

        .xword      LDUP
        .xword      ZEQU
        .xword      LIT, 5, QERR
        .xword      TDUP
        .xword      PRESENT
        .xword      LDUP
        .xword      ZBRAN
        .xword      CREA1-.-CW 
        .xword      TNFA, FETCH, SFET
        .xword      ETYPE
        .xword      LIT,4
        .xword      MESS
        .xword      X       
CREA1:  .xword      DROP
 .xword      LALIGN
        .xword      SCOMMA
 .xword      LALIGN
        .xword      HERE,TOR

        .xword      RR, TPHA, COMMA         
        .xword      RR, TPHA, COMMA         
        .xword      ZERO, COMMA 
        .xword      ZERO, COMMA 
        .xword      COMMA   


        .xword      BLK, FETCH, LDUP, ZEQU
        .xword      ZBRAN
        .xword      CREA2-.-CW
        .xword      DROP, PP, FETCH
CREA2:  .xword      COMMA  

                .xword      FROMR
        .xword      SEMIS






        .align 3
N_LLINK:
        .xword      4
        .ascii      "LINK"
        .align 3
LLINK:
        .xword    DOCOL
        .xword    LLINK+HEADSIZE
        .xword    0x0
        .xword    LHEAD
        .xword    N_LLINK
        .xword    0

        .xword      TLFA
        .xword      TDUP
        .xword      FETCH
        .xword      SWAP, TLFA, STOR
        .xword      STOR
        .xword      SEMIS






        .align 3
N_PCREAT:
        .xword      8
        .ascii      "(CREATE)"
        .align 3
PCREAT:
        .xword    DOCOL
        .xword    PCREAT+HEADSIZE
        .xword    0x0
        .xword    LLINK
        .xword    N_PCREAT
        .xword    0

        .xword      LHEAD
        .xword      CURR, FETCH
        .xword      LLINK
        .xword      SEMIS






        .align 3
N_BCOMP:
        .xword      9
        .ascii      "[COMPILE]"
        .align 3
BCOMP:
        .xword    DOCOL
        .xword    BCOMP+HEADSIZE
        .xword    B_IMMED
        .xword    PCREAT
        .xword    N_BCOMP
        .xword    0

        .xword      LNAME
        .xword      PRESENT
        .xword      LDUP
        .xword      ZEQU
        .xword      LIT, 16, QERR
        .xword      TCFA
        .xword      COMMA
        .xword      SEMIS






        .align 3
N_POSTP:
        .xword      8
        .ascii      "POSTPONE"
        .align 3
POSTP:
        .xword    DOCOL
        .xword    POSTP+HEADSIZE
        .xword    B_IMMED
        .xword    BCOMP
        .xword    N_POSTP
        .xword    0

        .xword      LNAME
        .xword      PRESENT
        .xword      LDUP
        .xword      ZEQU
        .xword      LIT, 15, QERR
        .xword      LDUP, TFFA, FETCH
        .xword      LIT, B_IMMED, LAND, ZEQU
        .xword      ZBRAN
        .xword      POSTP1-.-CW
         .xword      LIT, LIT, COMMA
         .xword      COMMA
         .xword      LIT, COMMA
POSTP1:
         .xword      COMMA
        .xword      SEMIS






        .align 3
N_LITER:
        .xword      7
        .ascii      "LITERAL"
        .align 3
LITER:
        .xword    DOCOL
        .xword    LITER+HEADSIZE
        .xword    B_IMMED
        .xword    POSTP
        .xword    N_LITER
        .xword    0

        .xword      STATE
        .xword      FETCH
        .xword      ZBRAN
        .xword      LITE1-.-CW 
        .xword      LIT, LIT, COMMA
        .xword      COMMA   
LITE1:  .xword      SEMIS






        .align 3
N_DLITE:
        .xword      8
        .ascii      "DLITERAL"
        .align 3
DLITE:
        .xword    DOCOL
        .xword    DLITE+HEADSIZE
        .xword    B_IMMED
        .xword    LITER
        .xword    N_DLITE
        .xword    0

        .xword      STATE
        .xword      FETCH
        .xword      ZBRAN
        .xword      DLIT1-.-CW 
        .xword      SWAP
        .xword      LITER
        .xword      LITER   
DLIT1:  .xword      SEMIS







        .align 3
N_SDLITE:
        .xword      9
        .ascii      "SDLITERAL"
        .align 3
SDLITE:
        .xword    DOCOL
        .xword    SDLITE+HEADSIZE
        .xword    B_IMMED
        .xword    DLITE
        .xword    N_SDLITE
        .xword    0

        .xword      DPL
        .xword      FETCH
        .xword      ZBRAN
        .xword      SDLIT1-.-CW 
        .xword      DLITE
        .xword      BRAN
        .xword      SDLIT2-.-CW 
SDLIT1:
        .xword      DROP, LITER
SDLIT2:
        .xword      SEMIS







        .align 3
N_QSTAC:
        .xword      6
        .ascii      "?STACK"
        .align 3
QSTAC:
        .xword    DOCOL
        .xword    QSTAC+HEADSIZE
        .xword    0x0
        .xword    SDLITE
        .xword    N_QSTAC
        .xword    0

        .xword      SPFET
        .xword      SZERO
        .xword      FETCH
        .xword      SWAP
        .xword      ULESS
        .xword      ONE, QERR
        .xword      SPFET
        .xword      HERE
        .xword      LIT,0x80
        .xword      PLUS
        .xword      ULESS
        .xword      LIT, 7, QERR
        .xword      SEMIS
        #







        .align 3
N_INTER:
        .xword      9
        .ascii      "INTERPRET"
        .align 3
INTER:
        .xword    DOCOL
        .xword    INTER+HEADSIZE
        .xword    0x0
        .xword    QSTAC
        .xword    N_INTER
        .xword    0

INTE1:
        .xword      LNAME
        .xword      LDUP      
        .xword      ZBRAN
        .xword      INTE8-.-CW 


        .xword      OVER, TOR       
        .xword      FOUND
        .xword      LDUP, ZEQU
        .xword      LIT, 12, QERR
        .xword      LDUP, TFFA, FETCH
        .xword      LDUP, LIT, B_DENOT, LAND 
        .xword      ZBRAN
        .xword      INTE3B-.-CW 
        .xword      OVER, TNFA, FETCH, FETCH
        .xword      RR, PLUS, PP, STOR  
INTE3B:                  
        .xword      RDROP           
        .xword      LIT, B_IMMED, LAND
        .xword      STATE, FETCH, ZEQU, LOR
        .xword      ZBRAN
        .xword      INTE3-.-CW 
        .xword      EXEC
        .xword      BRAN
        .xword      INTE4-.-CW 
INTE3:
        .xword      COMMA
                        
INTE4:
        .xword      QSTAC
        .xword      BRAN
        .xword      INTE1-.-CW  
INTE8:  .xword      DROP, DROP
        .xword      SEMIS






        .align 3
N_IMMED:
        .xword      9
        .ascii      "IMMEDIATE"
        .align 3
IMMED:
        .xword    DOCOL
        .xword    IMMED+HEADSIZE
        .xword    0x0
        .xword    INTER
        .xword    N_IMMED
        .xword    0

        .xword      LATEST
        .xword      TFFA
        .xword      LIT, B_IMMED
        .xword      TOGGL
        .xword      SEMIS






        .align 3
N_PREFX:
        .xword      6
        .ascii      "PREFIX"
        .align 3
PREFX:
        .xword    DOCOL
        .xword    PREFX+HEADSIZE
        .xword    0x0
        .xword    IMMED
        .xword    N_PREFX
        .xword    0

        .xword      LATEST
        .xword      TFFA
        .xword      LIT, B_DENOT
        .xword      TOGGL
        .xword      SEMIS






        .align 3
N_VOCAB:
        .xword      9
        .ascii      "NAMESPACE"
        .align 3
VOCAB:
        .xword    DOCOL
        .xword    VOCAB+HEADSIZE
        .xword    0x0
        .xword    PREFX
        .xword    N_VOCAB
        .xword    0

        .xword      LCREATE
        .xword      LATEST   
        .xword      VOCL
        .xword      FETCH
        .xword      COMMA
        .xword      VOCL
        .xword      STOR
        .xword      WORDLIST, DROP 
        .xword      DOES
DOVOC:
        .xword      ALSO
        .xword      CELLP   
        .xword      CONTEXT
        .xword      STOR
        .xword      SEMIS
        #










        .align 3
N_WORDLIST:
        .xword      8
        .ascii      "WORDLIST"
        .align 3
WORDLIST:
        .xword    DOCOL
        .xword    WORDLIST+HEADSIZE
        .xword    0x0
        .xword    VOCAB
        .xword    N_WORDLIST
        .xword    0

        .xword      HERE
        .xword      ZERO, COMMA   
        .xword      ZERO, COMMA   
        .xword      LIT, B_DUMMY, COMMA 
        .xword      ZERO, COMMA 
        .xword      LIT, (ZERO+(CW*(D_HOFFSET))), COMMA 
        .xword      ZERO, COMMA
                .xword      SEMIS
        #








        .align 3
N_DEFIN:
        .xword      11
        .ascii      "DEFINITIONS"
        .align 3
DEFIN:
        .xword    DOCOL
        .xword    DEFIN+HEADSIZE
        .xword    0x0
        .xword    WORDLIST
        .xword    N_DEFIN
        .xword    0

        .xword      CONTEXT
        .xword      FETCH
        .xword      CURR
        .xword      STOR
        .xword      SEMIS






        .align 3
N_ALSO:
        .xword      4
        .ascii      "ALSO"
        .align 3
ALSO:
        .xword    DOCOL
        .xword    ALSO+HEADSIZE
        .xword    0x0
        .xword    DEFIN
        .xword    N_ALSO
        .xword    0

        .xword      CONTEXT, LDUP, CELLP
        .xword      LIT, (CW*(16-1))
        .xword      LMOVE
        .xword      LIT, ONLYBODY  
        .xword      CONTEXT, LIT, (CW*(16)), PLUS
        .xword      STOR 
        .xword      SEMIS






        .align 3
N_PREVI:
        .xword      8
        .ascii      "PREVIOUS"
        .align 3
PREVI:
        .xword    DOCOL
        .xword    PREVI+HEADSIZE
        .xword    0x0
        .xword    ALSO
        .xword    N_PREVI
        .xword    0

        .xword      CONTEXT, LDUP, CELLP, SWAP
        .xword      LIT, (CW*(16))
        .xword      LMOVE
        .xword      SEMIS






        .align 3
N_PAREN:
        .xword      1
        .ascii      "("
        .align 3
PAREN:
        .xword    DOCOL
        .xword    PAREN+HEADSIZE
        .xword    B_IMMED
        .xword    PREVI
        .xword    N_PAREN
        .xword    0

        .xword      LIT,')'
        .xword      PARSE
        .xword      TDROP
        .xword      SEMIS







        .align 3
N_BACKS:
        .xword      1
        .ascii      "\\"
        .align 3
BACKS:
        .xword    DOCOL
        .xword    BACKS+HEADSIZE
        .xword    B_IMMED
        .xword    PAREN
        .xword    N_BACKS
        .xword    0


        .xword      LIT, -1, PP, PSTOR
        .xword      LIT,ALF
        .xword      PARSE
        .xword      TDROP
        .xword      SEMIS






        .align 3
N_QUIT:
        .xword      4
        .ascii      "QUIT"
        .align 3
QUIT:
        .xword    DOCOL
        .xword    QUIT+HEADSIZE
        .xword    0x0
        .xword    BACKS
        .xword    N_QUIT
        .xword    0

        .xword      LBRAC
QUIT1:                  
        .xword      RZERO
        .xword      FETCH
        .xword      RPSTO





        .xword      LIT
        .xword      PACCEP
        .xword      CATCH
        .xword      LDUP, LIT, -EPIPE, EQUAL
        .xword      ZBRAN
        .xword      ENDIF7-.-CW
        .xword      BYE     
ENDIF7:
        .xword      QERRUR
        .xword      ONEP

        .xword      SETSRC
        .xword      INTER
        .xword      OK
        .xword      BRAN
        .xword      QUIT1-.-CW  
        .xword      SEMIS   






        .align 3
N_OK:
        .xword      2
        .ascii      "OK"
        .align 3
OK:
        .xword    DOCOL
        .xword    OK+HEADSIZE
        .xword    0x0
        .xword    QUIT
        .xword    N_OK
        .xword    0

        .xword      STATE
        .xword      FETCH
        .xword      ZEQU
        .xword      ZBRAN
        .xword      OK2-.-CW 
        .xword      SKIP
         .xword      3
SB2: .ascii      " OK"
       .align 3
        .xword      LIT, SB2
        .xword      LIT, 3
        .xword      LTYPE
        .xword      CR
OK2:
        .xword      SEMIS







        .align 3
N_OPTIONS:
        .xword      7
        .ascii      "OPTIONS"
        .align 3
OPTIONS:
        .xword    DOCOL
        .xword    OPTIONS+HEADSIZE
        .xword    0x0
        .xword    OK
        .xword    N_OPTIONS
        .xword    0


        .xword      ARGS, FETCH, CELLP, CELLP, FETCH, LDUP
        .xword      ZBRAN
        .xword      OPT4-.-CW 





        .xword      COUNT

        .xword      LIT, '-', UNEQ
        .xword      ZBRAN
        .xword      OPT3-.-CW
        .xword      LIT, 3, LDUP, LERROR
        .xword      XCODE, STOR, BYE
OPT3:
        .xword      CFET
        .xword      LIT, 0x1F, LAND
        .xword      LLOAD       
        .xword      ZERO, SWAP 
OPT4:
        .xword      DROP
        .xword      SEMIS   







        .align 3
N_INIT:
        .xword      5
        .ascii      "_INIT"
        .align 3
INIT:
        .xword    DOCOL
        .xword    INIT+HEADSIZE
        .xword    0x0
        .xword    OPTIONS
        .xword    N_INIT
        .xword    0

        .xword      SZERO, FETCH, SPSTO
        .xword      ZERO, HANDLER, STOR
        .xword      DECA
        .xword      ONLY, FORTH, DEFIN

        .xword      LIT, 0, BLINI  

        .xword      SEMIS







        .align 3
N_STOD:
        .xword      3
        .ascii      "S>D"
        .align 3
STOD:
        .xword    STOD+HEADSIZE
        .xword    STOD+HEADSIZE
        .xword    0x0
        .xword    INIT
        .xword    N_STOD
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        MOV    X0,#0
        ANDS    X1,X1,X1
        BPL     STOD1   
        SUB     X0,X0, #1      
STOD1:
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_LABS:
        .xword      3
        .ascii      "ABS"
        .align 3
LABS:
        .xword    DOCOL
        .xword    LABS+HEADSIZE
        .xword    0x0
        .xword    STOD
        .xword    N_LABS
        .xword    0

        .xword      LDUP
        .xword      ZLESS
        .xword      ZBRAN
        .xword      PM1-.-CW   
        .xword      NEGATE   
PM1:
        .xword      SEMIS






        .align 3
N_DABS:
        .xword      4
        .ascii      "DABS"
        .align 3
DABS:
        .xword    DOCOL
        .xword    DABS+HEADSIZE
        .xword    0x0
        .xword    LABS
        .xword    N_DABS
        .xword    0

        .xword      LDUP
        .xword      ZLESS
        .xword      ZBRAN
        .xword      DPM1-.-CW  
        .xword      DNEGA   
DPM1:
        .xword      SEMIS






        .align 3
N_MIN:
        .xword      3
        .ascii      "MIN"
        .align 3
MIN:
        .xword    DOCOL
        .xword    MIN+HEADSIZE
        .xword    0x0
        .xword    DABS
        .xword    N_MIN
        .xword    0

        .xword      TDUP
        .xword      GREAT
        .xword      ZBRAN
        .xword      MIN1-.-CW  
        .xword      SWAP    
MIN1:   .xword      DROP
        .xword      SEMIS






        .align 3
N_MAX:
        .xword      3
        .ascii      "MAX"
        .align 3
MAX:
        .xword    DOCOL
        .xword    MAX+HEADSIZE
        .xword    0x0
        .xword    MIN
        .xword    N_MAX
        .xword    0

        .xword      TDUP
        .xword      LESS
        .xword      ZBRAN
        .xword      MAX1-.-CW  
        .xword      SWAP    
MAX1:   .xword      DROP
        .xword      SEMIS






        .align 3
N_LSHIFT:
        .xword      6
        .ascii      "LSHIFT"
        .align 3
LSHIFT:
        .xword    LSHIFT+HEADSIZE
        .xword    LSHIFT+HEADSIZE
        .xword    0x0
        .xword    MAX
        .xword    N_LSHIFT
        .xword    0

        LDR     X2, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
         LSL X0,X0, X2
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_RSHIFT:
        .xword      6
        .ascii      "RSHIFT"
        .align 3
RSHIFT:
        .xword    RSHIFT+HEADSIZE
        .xword    RSHIFT+HEADSIZE
        .xword    0x0
        .xword    LSHIFT
        .xword    N_RSHIFT
        .xword    0

        LDR     X2, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        LSR X0,X0, X2
         STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_ARSHIFT:
        .xword      7
        .ascii      "ARSHIFT"
        .align 3
ARSHIFT:
        .xword    ARSHIFT+HEADSIZE
        .xword    ARSHIFT+HEADSIZE
        .xword    0x0
        .xword    RSHIFT
        .xword    N_ARSHIFT
        .xword    0

        LDR     X2, [X13],#+(CW*(1))
        LDR     X0, [X13],#+(CW*(1))
        ASR X0,X0, X2
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_MSTAR:
        .xword      2
        .ascii      "M*"
        .align 3
MSTAR:
        .xword    MSTAR+HEADSIZE
        .xword    MSTAR+HEADSIZE
        .xword    0x0
        .xword    ARSHIFT
        .xword    N_MSTAR
        .xword    0

        LDR     X3, [X13],#+(CW*(1))
        LDR     X2, [X13],#+(CW*(1))
 

        MUL      X1,X2,X3          
        SMULH    X0,X2,X3          
        STR     X1, [X13,#-(CW*(1))]!
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            







        .align 3
N_MSLAS:
        .xword      6
        .ascii      "SM/REM"
        .align 3
MSLAS:
        .xword    DOCOL
        .xword    MSLAS+HEADSIZE
        .xword    0x0
        .xword    MSTAR
        .xword    N_MSLAS
        .xword    0

        .xword      OVER, TOR, TOR, DABS  
        .xword      RR, LABS, USLAS       
        .xword      FROMR, RR, LXOR       
        .xword      ZLESS                 
        .xword      ZBRAN
        .xword      MSLAS1-.-CW
        .xword      NEGATE
MSLAS1:
        .xword      SWAP, FROMR           
        .xword      ZLESS                 
        .xword      ZBRAN
        .xword      MSLAS2-.-CW
        .xword      NEGATE
MSLAS2:
        .xword      SWAP                  
        .xword      SEMIS

 /* 
CODE_HEADER({SM/REM},{MSLAS})
        POP(R8)      _C{DIVISOR}
        POP(R10)     _C{MSW OF DIVIDEND}
        POP(R0)      _C{LSW OF DIVIDEND}
        BL           IDIV _C{ not yet 64 bit/32 bit signed}
        _2PUSH_R10          _C{STORE QUOT/REM}
_C


_C{ Divide routine 32/32 signed from Henry Thomas (http://me.henri.net/fp-div.html)}
_C{ Entry  R0: numerator (lo) must be signed positive}
_C{        R8: denominator (den aka divisor) must be non-zero and signed negative}
IDIV:

        lo .req R0
        hi .req R10
        den .req R8
        MOVI  R5, #0   _C{ R5 is sign-memory of den}
        CMP den, #0
        BMI IDIV1
        MVN den,den  _C{ den  <-- two-complement of den}
        ADD den, den, #1
        MOVI  R5, #-1
IDIV1:  MOVI  R6, #0   _C{ R6 is sign-memory of lo}
        CMP lo,#0
        BPL IDIV2
        MVN lo,lo    _C{ lo <-- two-complement of lo}
        ADD lo,lo,#1
        MOVI  R6,#-1

_C{the original routine:}
_C{with positive numerator and negative denominator}

IDIV2:  MOVI  hi, #0 _C{ hi = 0}
        ADDS lo, lo, lo
        .rept 32 _C{ repeat 32 times}
          ADCS hi, den, hi, lsl #1
          SUBCC hi, hi, den
          ADCS lo,lo
        .endr
_C{end of original routine}

        _C{ remainder has sign of numerator}
        CMP R6, #0
        BEQ IDIV3
        MVN hi, hi  _C{ hi  <-- two-complement of remainder}
        ADD hi, hi, #1

IDIV3:
        _C{ quotient has both signs of numerator and denominator}
        CMP R5,R6
        BNE IDIV4
        MVN lo,lo    _C{ lo <-- two-complement of lo}
        ADD lo,lo,#1
IDIV4:
        MOV PC, LR _C{ return}
_C{Exit   R0:  quotient (lo)}
_C{       R10: remainder (hi)}
 */  






        .align 3
N_TWOSL:
        .xword      2
        .ascii      "2/"
        .align 3
TWOSL:
        .xword    DOCOL
        .xword    TWOSL+HEADSIZE
        .xword    0x0
        .xword    MSLAS
        .xword    N_TWOSL
        .xword    0

        .xword      STOD, TWO, FMSLAS
        .xword      NIP
        .xword      SEMIS






        .align 3
N_TWOST:
        .xword      2
        .ascii      "2*"
        .align 3
TWOST:
        .xword    DOCOL
        .xword    TWOST+HEADSIZE
        .xword    0x0
        .xword    TWOSL
        .xword    N_TWOST
        .xword    0

        .xword      TWO, STAR
        .xword      SEMIS






        .align 3
N_ONEM:
        .xword      2
        .ascii      "1-"
        .align 3
ONEM:
        .xword    DOCOL
        .xword    ONEM+HEADSIZE
        .xword    0x0
        .xword    TWOST
        .xword    N_ONEM
        .xword    0

        .xword      ONE, LSUB
        .xword      SEMIS






        .align 3
N_FMSLAS:
        .xword      6
        .ascii      "FM/MOD"
        .align 3
FMSLAS:
        .xword    DOCOL
        .xword    FMSLAS+HEADSIZE
        .xword    0x0
        .xword    ONEM
        .xword    N_FMSLAS
        .xword    0

        .xword      LDUP, TOR
        .xword      TDUP, LXOR, TOR
        .xword      MSLAS
        .xword      FROMR, ZLESS
        .xword      ZBRAN
        .xword      FMMOD1-.-CW
        .xword      OVER
        .xword      ZBRAN
        .xword      FMMOD1-.-CW
        .xword      ONE, LSUB
        .xword      SWAP, FROMR, PLUS, SWAP
        .xword      BRAN
        .xword      FMMOD2-.-CW
FMMOD1:
        .xword      RDROP
FMMOD2:
        .xword      SEMIS






        .align 3
N_STAR:
        .xword      1
        .ascii      "*"
        .align 3
STAR:
        .xword    DOCOL
        .xword    STAR+HEADSIZE
        .xword    0x0
        .xword    FMSLAS
        .xword    N_STAR
        .xword    0

        .xword      MSTAR
        .xword      DROP
        .xword      SEMIS






        .align 3
N_SLMOD:
        .xword      4
        .ascii      "/MOD"
        .align 3
SLMOD:
        .xword    DOCOL
        .xword    SLMOD+HEADSIZE
        .xword    0x0
        .xword    STAR
        .xword    N_SLMOD
        .xword    0

        .xword      TOR
        .xword      STOD
        .xword      FROMR
        .xword      MSLAS
        .xword      SEMIS






        .align 3
N_SLASH:
        .xword      1
        .ascii      "/"
        .align 3
SLASH:
        .xword    DOCOL
        .xword    SLASH+HEADSIZE
        .xword    0x0
        .xword    SLMOD
        .xword    N_SLASH
        .xword    0

        .xword      SLMOD
        .xword      NIP
        .xword      SEMIS






        .align 3
N_LMOD:
        .xword      3
        .ascii      "MOD"
        .align 3
LMOD:
        .xword    DOCOL
        .xword    LMOD+HEADSIZE
        .xword    0x0
        .xword    SLASH
        .xword    N_LMOD
        .xword    0

        .xword      SLMOD
        .xword      DROP
        .xword      SEMIS






        .align 3
N_SSMOD:
        .xword      5
        .ascii      "*/MOD"
        .align 3
SSMOD:
        .xword    DOCOL
        .xword    SSMOD+HEADSIZE
        .xword    0x0
        .xword    LMOD
        .xword    N_SSMOD
        .xword    0

        .xword      TOR
        .xword      MSTAR
        .xword      FROMR
        .xword      MSLAS
        .xword      SEMIS






        .align 3
N_SSLA:
        .xword      2
        .ascii      "*/"
        .align 3
SSLA:
        .xword    DOCOL
        .xword    SSLA+HEADSIZE
        .xword    0x0
        .xword    SSMOD
        .xword    N_SSLA
        .xword    0

        .xword      SSMOD
        .xword      NIP
        .xword      SEMIS






        .align 3
N_MSMOD1:
        .xword      5
        .ascii      "M/MOD"
        .align 3
MSMOD1:
        .xword    DOCOL
        .xword    MSMOD1+HEADSIZE
        .xword    0x0
        .xword    SSLA
        .xword    N_MSMOD1
        .xword    0





        .align 3
N_MSMOD:
        .xword      7
        .ascii      "UDM/MOD"
        .align 3
MSMOD:
        .xword    DOCOL
        .xword    MSMOD+HEADSIZE
        .xword    0x0
        .xword    MSMOD1
        .xword    N_MSMOD
        .xword    0

        .xword      TOR
        .xword      ZERO
        .xword      RR
        .xword      USLAS
        .xword      FROMR
        .xword      SWAP
        .xword      TOR
        .xword      USLAS
        .xword      FROMR
        .xword      SEMIS






        .align 3
N_PLINE:
        .xword      6
        .ascii      "(LINE)"
        .align 3
PLINE:
        .xword    DOCOL
        .xword    PLINE+HEADSIZE
        .xword    0x0
        .xword    MSMOD
        .xword    N_PLINE
        .xword    0

        .xword      TOR
        .xword      LIT,64
        .xword      MSTAR
        .xword      BBUF
        .xword      FMSLAS
        .xword      FROMR 
        .xword      PLUS
        .xword      BLOCK
        .xword      PLUS
        .xword      LIT,63
        .xword      SEMIS






        .align 3
N_ERRSCR:
        .xword      6
        .ascii      "ERRSCR"
        .align 3
ERRSCR:
        .xword    DOVAR
        .xword    ERRSCR+HEADSIZE
        .xword    0x0
        .xword    PLINE
        .xword    N_ERRSCR
        .xword    0

        .xword ERRORSCREEN






        .align 3
N_MESS:
        .xword      7
        .ascii      "MESSAGE"
        .align 3
MESS:
        .xword    DOCOL
        .xword    MESS+HEADSIZE
        .xword    0x0
        .xword    ERRSCR
        .xword    N_MESS
        .xword    0

        .xword      LWARN
        .xword      FETCH
        .xword      ZBRAN
        .xword      MESS1-.-CW 
        .xword      ERRSCR, FETCH
        .xword      PLINE, ONEP     
        .xword      ETYPE
        .xword      X
MESS1:                  
        .xword      DROP
        .xword      SEMIS






 /* 
 Dit blok  PC@,PC!,PW@,PW! eerst maar even uitgeschakeld voor ARM !
 Dit moet waarschijnlijk helemaal anders als voor Intel
 */  




        .align 3
N_PCFET:
        .xword      3
        .ascii      "PC@"
        .align 3
PCFET:
        .xword    PCFET+HEADSIZE
        .xword    PCFET+HEADSIZE
        .xword    0x0
        .xword    MESS
        .xword    N_PCFET
        .xword    0


        LDR     X1, [X13],#+(CW*(1))      
        MOV     X0,#0

        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PCSTO:
        .xword      3
        .ascii      "PC!"
        .align 3
PCSTO:
        .xword    PCSTO+HEADSIZE
        .xword    PCSTO+HEADSIZE
        .xword    0x0
        .xword    PCFET
        .xword    N_PCSTO
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      

        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PFET:
        .xword      3
        .ascii      "PW@"
        .align 3
PFET:
        .xword    PFET+HEADSIZE
        .xword    PFET+HEADSIZE
        .xword    0x0
        .xword    PCSTO
        .xword    N_PFET
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      

        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  






        .align 3
N_PSTO:
        .xword      3
        .ascii      "PW!"
        .align 3
PSTO:
        .xword    PSTO+HEADSIZE
        .xword    PSTO+HEADSIZE
        .xword    0x0
        .xword    PFET
        .xword    N_PSTO
        .xword    0

        LDR     X1, [X13],#+(CW*(1))      
        LDR     X0, [X13],#+(CW*(1))      

        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1  








        .align 3
N__PREV:
        .xword      5
        .ascii      "_PREV"
        .align 3
_PREV:
        .xword    DOVAR
        .xword    _PREV+HEADSIZE
        .xword    0x0
        .xword    PSTO
        .xword    N__PREV
        .xword    0

        .xword      BUF1








        .align 3
N_NOBUF:
        .xword      5
        .ascii      "#BUFF"
        .align 3
NOBUF:
        .xword    DOCON
        .xword    NBUF
        .xword    0x0
        .xword    _PREV
        .xword    N_NOBUF
        .xword    0







        .align 3
N_PBUF:
        .xword      4
        .ascii      "+BUF"
        .align 3
PBUF:
        .xword    DOCOL
        .xword    PBUF+HEADSIZE
        .xword    0x0
        .xword    NOBUF
        .xword    N_PBUF
        .xword    0

        .xword      BBUF, CELLP, CELLP
        .xword      PLUS,LDUP
        .xword      _LIMIT,EQUAL
        .xword      ZBRAN
        .xword      PBUF1-.-CW
        .xword      DROP,_FIRST
PBUF1:  .xword      LDUP, _PREV, FETCH, LSUB
        .xword      SEMIS






        .align 3
N_UPDAT:
        .xword      6
        .ascii      "UPDATE"
        .align 3
UPDAT:
        .xword    DOCOL
        .xword    UPDAT+HEADSIZE
        .xword    0x0
        .xword    PBUF
        .xword    N_UPDAT
        .xword    0

        .xword      _PREV, FETCH
        .xword      LDUP, CELLP,CELLP
        .xword      SWAP, FETCH
        .xword      LOFFSET,  FETCH, PLUS
        .xword      BLWRITE
        .xword      SEMIS






        .align 3
N_MTBUF:
        .xword      13
        .ascii      "EMPTY-BUFFERS"
        .align 3
MTBUF:
        .xword    DOCOL
        .xword    MTBUF+HEADSIZE
        .xword    0x0
        .xword    UPDAT
        .xword    N_MTBUF
        .xword    0

        .xword      _FIRST
        .xword      _LIMIT,OVER
        .xword      LSUB,LERASE
        .xword      _FIRST, _PREV, STOR
        .xword      SEMIS
        #






        .align 3
N_BUFFER:
        .xword      8
        .ascii      "(BUFFER)"
        .align 3
BUFFER:
        .xword    DOCOL
        .xword    BUFFER+HEADSIZE
        .xword    0x0
        .xword    MTBUF
        .xword    N_BUFFER
        .xword    0


    .xword      _PREV, FETCH
BUFFER1:
    .xword          TOR, RR, FETCH, OVER, EQUAL
    .xword      ZBRAN
        .xword      BUFFER3-.-CW
    .xword        DROP, FROMR, EXIT
BUFFER3:
    .xword          FROMR
    .xword      PBUF, ZEQU
    .xword      ZBRAN
        .xword      BUFFER1-.-CW

BUFFER2:
    .xword       PBUF, ZEQU, LIT, 48, QERR  
    .xword       LDUP, CELLP, FETCH
    .xword       LIT, -1, GREAT        
    .xword      ZBRAN
        .xword      BUFFER2-.-CW
    .xword       TOR

    .xword       RR, STOR
    .xword       ZERO, RR, CELLP, STOR

    .xword       RR, _PREV, STOR
    .xword       FROMR
    .xword  SEMIS







        .align 3
N_BLOCK:
        .xword      5
        .ascii      "BLOCK"
        .align 3
BLOCK:
        .xword    DOCOL
        .xword    BLOCK+HEADSIZE
        .xword    0x0
        .xword    BUFFER
        .xword    N_BLOCK
        .xword    0


        .xword      BUFFER
        .xword      LDUP, CELLP, FETCH, ONE, LAND, ZEQU
        .xword      ZBRAN
        .xword      BLOCK1-.-CW
        .xword      LDUP, CELLP, CELLP
        .xword      OVER, FETCH
        .xword      LOFFSET,  FETCH, PLUS
        .xword      BLREAD
        .xword      LDUP, CELLP, ONE, TOGGL
BLOCK1:
        .xword      LDUP, _PREV, STOR
        .xword      CELLP, CELLP
        .xword      SEMIS






        .align 3
N_FLUSH:
        .xword      5
        .ascii      "FLUSH"
        .align 3
FLUSH:
        .xword    DOCOL
        .xword    (MTBUF+HEADSIZE)
        .xword    0x0
        .xword    BLOCK
        .xword    N_FLUSH
        .xword    0



        .xword      _LIMIT
        .xword      _FIRST, CELLP
        .xword     XDO
        .xword      FLUS2-.-CW
FLUS1:  .xword      ZERO, IDO, STOR
        .xword      LIT,(KBBUF+2*CW)
        .xword      PLOOP
        .xword      (FLUS1-.)
FLUS2:
        .xword      SEMIS






        .align 3
N_SAVE:
        .xword      4
        .ascii      "SAVE"
        .align 3
SAVE:
        .xword    DOCOL
        .xword    SAVE+HEADSIZE
        .xword    0x0
        .xword    FLUSH
        .xword    N_SAVE
        .xword    0

        .xword      FROMR
        .xword      SRC, TFET
        .xword      PP, FETCH
        .xword      TOR, TOR, TOR
        .xword      TOR
        .xword SEMIS






        .align 3
N_RESTO:
        .xword      7
        .ascii      "RESTORE"
        .align 3
RESTO:
        .xword    DOCOL
        .xword    RESTO+HEADSIZE
        .xword    0x0
        .xword    SAVE
        .xword    N_RESTO
        .xword    0

        .xword      FROMR
        .xword      FROMR, FROMR, FROMR
        .xword      PP, STOR
        .xword      SRC, TSTOR
        .xword      TOR
        .xword SEMIS












        .align 3
N_LLOCK:
        .xword      4
        .ascii      "LOCK"
        .align 3
LLOCK:
        .xword    DOCOL
        .xword    LLOCK+HEADSIZE
        .xword    0x0
        .xword    RESTO
        .xword    N_LLOCK
        .xword    0

        .xword      BUFFER
        .xword      CELLP
        .xword      LIT, -2, SWAP, PSTOR
        .xword      SEMIS






        .align 3
N_LUNLOCK:
        .xword      6
        .ascii      "UNLOCK"
        .align 3
LUNLOCK:
        .xword    DOCOL
        .xword    LUNLOCK+HEADSIZE
        .xword    0x0
        .xword    LLOCK
        .xword    N_LUNLOCK
        .xword    0

        .xword      BUFFER
        .xword      CELLP
        .xword      TWO, SWAP, PSTOR
        .xword      SEMIS






        .align 3
N_LLOAD:
        .xword      4
        .ascii      "LOAD"
        .align 3
LLOAD:
        .xword    DOCOL
        .xword    LLOAD+HEADSIZE
        .xword    0x0
        .xword    LUNLOCK
        .xword    N_LLOAD
        .xword    0

        .xword      SAVE
        .xword      TOR
        .xword      RR, LIT, LLOCK, CATCH  
        .xword      LDUP, ZEQU
        .xword      ZBRAN
        .xword      LOAD5-.-CW
        .xword      DROP
        .xword      RR, BLOCK     
        .xword      BBUF
        .xword      SETSRC
        .xword      LIT, INTER, CATCH
        .xword      RR, LUNLOCK
LOAD5:
        .xword      RDROP
        .xword      RESTO
        .xword      THROW
        .xword      SEMIS






        .align 3
N_THRU:
        .xword      4
        .ascii      "THRU"
        .align 3
THRU:
        .xword    DOCOL
        .xword    THRU+HEADSIZE
        .xword    0x0
        .xword    LLOAD
        .xword    N_THRU
        .xword    0

        .xword      ONEP, SWAP
        .xword     XDO
        .xword      THRU2-.-CW
THRU1:
        .xword      IDO, LLOAD
        .xword     ONE, XPLOOP, ZBRAN
        .xword      THRU1-.-CW
	.xword      UNLOOP
THRU2:
        .xword      SEMIS







        .align 3
N_BLK:
        .xword      3
        .ascii      "BLK"
        .align 3
BLK:
        .xword    DOCOL
        .xword    BLK+HEADSIZE
        .xword    0x0
        .xword    THRU
        .xword    N_BLK
        .xword    0

        .xword      PP, FETCH
        .xword      _FIRST, _LIMIT, WITHIN
        .xword      SRC, TFET, LSUB
        .xword      LIT, 1024, EQUAL, LAND
        .xword      ZBRAN
        .xword      BLK1-.-CW
        .xword      SRC, FETCH, TWO, LCELLS, LSUB, FETCH
        .xword      BRAN
        .xword      BLK2-.-CW
BLK1:
        .xword      ZERO
BLK2:
        .xword      PBLK, STOR
        .xword      PBLK
        .xword      SEMIS










        .align 3
N_XOS:
        .xword      3
        .ascii      "XOS"
        .align 3
XOS:
        .xword    XOS+HEADSIZE
        .xword    XOS+HEADSIZE
        .xword    0x0
        .xword    BLK
        .xword    N_XOS
        .xword    0




        LDR     X8, [X13],#+(CW*(1))       
        LDR     X2, [X13],#+(CW*(1))       
        LDR     X1, [X13],#+(CW*(1))       
        LDR     X0, [X13],#+(CW*(1))       
        SVC     #0          
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1       


 











        .align 3
N_XOS5:
        .xword      4
        .ascii      "XOS5"
        .align 3
XOS5:
        .xword    XOS5+HEADSIZE
        .xword    XOS5+HEADSIZE
        .xword    0x0
        .xword    XOS
        .xword    N_XOS5
        .xword    0

        LDR     X8, [X13],#+(CW*(1))        
        LDR     X4, [X13],#+(CW*(1))        
        LDR     X3, [X13],#+(CW*(1))        
        LDR     X2, [X13],#+(CW*(1))        
        LDR     X1, [X13],#+(CW*(1))        
        LDR     X0, [X13],#+(CW*(1))        
        SVC     #0           
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            









        .align 3
N_XOS7:
        .xword      4
        .ascii      "XOS7"
        .align 3
XOS7:
        .xword    XOS7+HEADSIZE
        .xword    XOS7+HEADSIZE
        .xword    0x0
        .xword    XOS5
        .xword    N_XOS7
        .xword    0

        LDR     X8, [X13],#+(CW*(1))        
        LDR     X6, [X13],#+(CW*(1))        
        LDR     X5, [X13],#+(CW*(1))        
        LDR     X4, [X13],#+(CW*(1))        
        LDR     X3, [X13],#+(CW*(1))        
        LDR     X2, [X13],#+(CW*(1))        
        LDR     X1, [X13],#+(CW*(1))        
        LDR     X0, [X13],#+(CW*(1))        
        SVC     #0           
        STR     X0, [X13,#-(CW*(1))]!
        LDR     X0, [X11],#+(CW*(1))
         LDR     X1,[X0]
         BR      X1            




 






        .align 3
N_MS:
        .xword      2
        .ascii      "MS"
        .align 3
MS:
        .xword    DOCOL
        .xword    MS+HEADSIZE
        .xword    0x0
        .xword    XOS7
        .xword    N_MS
        .xword    0




        .xword      LIT, 1000000, LIT, 1000000000, SSMOD 
        .xword      LIT, TV, TSTOR
        .xword      ZERO, ZERO
        .xword      ZERO, ZERO
        .xword      LIT, TV
        .xword      ZERO, ZERO
        .xword      LIT, select, XOS7


        .xword      QERRUR
        .xword      SEMIS
TV:     .space    (CW*(2))    



        #














        .align 3
N_RWBUF:
        .xword      9
        .ascii      "RW-BUFFER"
        .align 3
RWBUF:
        .xword    DOVAR
        .xword    RWBUF+HEADSIZE
        .xword    0x0
        .xword    MS
        .xword    N_RWBUF
        .xword    0

        .space    0x1000









        .align 3
N_ZEN:
        .xword      3
        .ascii      "ZEN"
        .align 3
ZEN:
        .xword    DOCOL
        .xword    ZEN+HEADSIZE
        .xword    0x0
        .xword    RWBUF
        .xword    N_ZEN
        .xword    0

        .xword      RWBUF, SSTOR
        .xword      ZERO, RWBUF, CHAPP
        .xword      RWBUF, CELLP

        .xword      SEMIS











        .align 3
N_OFILE:
        .xword      9
        .ascii      "OPEN-FILE"
        .align 3
OFILE:
        .xword    DOCOL
        .xword    OFILE+HEADSIZE
        .xword    0x0
        .xword    ZEN
        .xword    N_OFILE
        .xword    0


      .xword      TOR, ZEN
       .xword       LIT, AT_FDCWD, SWAP, FROMR
       .xword      LIT, openat, XOS
       .xword      LDUP, ZERO, MIN
       .xword      SEMIS 










        .align 3
N_CFILE:
        .xword      10
        .ascii      "CLOSE-FILE"
        .align 3
CFILE:
        .xword    DOCOL
        .xword    CFILE+HEADSIZE
        .xword    0x0
        .xword    OFILE
        .xword    N_CFILE
        .xword    0

        .xword      X, X
        .xword      LIT, close, XOS
        .xword      SEMIS











        .align 3
N_CREATEF:
        .xword      11
        .ascii      "CREATE-FILE"
        .align 3
CREATEF:
        .xword    DOCOL
        .xword    CREATEF+HEADSIZE
        .xword    0x0
        .xword    CFILE
        .xword    N_CREATEF
        .xword    0


        .xword      TOR, TDUP, DFILE, DROP
      .xword      ZEN, LIT, AT_FDCWD, SWAP
        .xword     LIT, O_CREAT + O_TRUNC + O_WRONLY
        .xword      FROMR
        .xword      ZERO      
        .xword      LIT, openat, XOS5
        .xword      LDUP, ZERO, MIN
        .xword      SEMIS 











        .align 3
N_DFILE:
        .xword      11
        .ascii      "DELETE-FILE"
        .align 3
DFILE:
        .xword    DOCOL
        .xword    DFILE+HEADSIZE
        .xword    0x0
        .xword    CREATEF
        .xword    N_DFILE
        .xword    0


      .xword      ZEN
     .xword     LIT, AT_FDCWD, SWAP, ZERO
        .xword      LIT, unlinkat, XOS
        .xword      SEMIS 










        .align 3
N_RFILE:
        .xword      9
        .ascii      "READ-FILE"
        .align 3
RFILE:
        .xword    DOCOL
        .xword    RFILE+HEADSIZE
        .xword    0x0
        .xword    DFILE
        .xword    N_RFILE
        .xword    0

        .xword      ROT, ROT
        .xword      LIT, read, XOS
        .xword      LDUP, ZERO, MAX, SWAP, ZERO, MIN
        .xword      SEMIS









        .align 3
N_FPFILE:
        .xword      13
        .ascii      "FILE-POSITION"
        .align 3
FPFILE:
        .xword    DOCOL
        .xword    FPFILE+HEADSIZE
        .xword    0x0
        .xword    RFILE
        .xword    N_FPFILE
        .xword    0

        .xword      ZERO
        .xword      LIT, SEEK_CUR
        .xword      LIT, lseek, XOS
        .xword      ZERO     
        .xword      OVER, LDUP
        .xword      NEGATE, LIT, 256, ULESS, LAND 
        .xword      SEMIS
 








        .align 3
N_PFILE:
        .xword      15
        .ascii      "REPOSITION-FILE"
        .align 3
PFILE:
        .xword    DOCOL
        .xword    PFILE+HEADSIZE
        .xword    0x0
        .xword    FPFILE
        .xword    N_PFILE
        .xword    0

        .xword      TOR, DROP, FROMR   
        .xword      SWAP
        .xword      LIT, SEEK_SET
        .xword      LIT, lseek, XOS
        .xword      ZERO, MIN
        .xword      SEMIS
 










        .align 3
N_WFILE:
        .xword      10
        .ascii      "WRITE-FILE"
        .align 3
WFILE:
        .xword    DOCOL
        .xword    WFILE+HEADSIZE
        .xword    0x0
        .xword    PFILE
        .xword    N_WFILE
        .xword    0

        .xword      ROT, ROT
        .xword      LIT, write, XOS
        .xword      ZERO, MIN
        .xword      SEMIS











        .align 3
N_GETFILE:
        .xword      8
        .ascii      "GET-FILE"
        .align 3
GETFILE:
        .xword    DOCOL
        .xword    GETFILE+HEADSIZE
        .xword    0x0
        .xword    WFILE
        .xword    N_GETFILE
        .xword    0

     .xword LALIGN
        .xword      TDUP, SCOMMA, DROP
        .xword      LIT, 'F'+(0x100*('i'+0x100*('L'+0x100*'e'))), COMMA 
        .xword      ZERO, OFILE, THROW, TOR
        .xword      HERE, LDUP
        .xword      LEM, LIT, 6, SLASH, LDUP, ALLOT
        .xword      LIT, 1000, LSUB
        .xword      RR, RFILE, THROW
        .xword      FROMR, CFILE, THROW
        .xword      TDUP, PLUS, LDP, STOR        
        .xword      SEMIS






        .align 3
N_PUTFILE:
        .xword      8
        .ascii      "PUT-FILE"
        .align 3
PUTFILE:
        .xword    DOCOL
        .xword    PUTFILE+HEADSIZE
        .xword    0x0
        .xword    GETFILE
        .xword    N_PUTFILE
        .xword    0

        .xword      LIT, 0755
        .xword      CREATEF, THROW
        .xword      LDUP, TOR
        .xword      WFILE, THROW
        .xword      FROMR, CFILE, THROW
        .xword      SEMIS






        .align 3
N_INCLUDED:
        .xword      8
        .ascii      "INCLUDED"
        .align 3
INCLUDED:
        .xword    DOCOL
        .xword    INCLUDED+HEADSIZE
        .xword    0x0
        .xword    PUTFILE
        .xword    N_INCLUDED
        .xword    0

        .xword      HERE, TOR
        .xword      LIT, GETFILE, CATCH
        .xword      LDUP
        .xword      ZBRAN
        .xword      INCLUD1-.-CW
        .xword      FROMR, LDP, STOR
        .xword      THROW
        .xword      BRAN
        .xword      INCLUD2-.-CW
INCLUD1:
        .xword      RDROP, DROP
INCLUD2:
        .xword      EVALUATE
        .xword      SEMIS






        .align 3
N_LINCLUD:
        .xword      7
        .ascii      "INCLUDE"
        .align 3
LINCLUD:
        .xword    DOCOL
        .xword    LINCLUD+HEADSIZE
        .xword    0x0
        .xword    INCLUDED
        .xword    N_LINCLUD
        .xword    0

        .xword      LNAME, INCLUDED
        .xword      SEMIS






        .align 3
N_REFTIB:
        .xword      10
        .ascii      "REFILL-TIB"
        .align 3
REFTIB:
        .xword    DOCOL
        .xword    REFTIB+HEADSIZE
        .xword    0x0
        .xword    LINCLUD
        .xword    N_REFTIB
        .xword    0

        .xword      REMAIND, FETCH, TOR
        .xword      TIB, FETCH, RR, PLUS
        .xword      LIT, TIBSIZE, RR, LSUB
        .xword      ZERO
        .xword      RFILE
        .xword      QERRUR
        .xword      LDUP, ZEQU, LIT, -EPIPE, LAND 
        .xword      QERRUR
        .xword      TIB, FETCH, SWAP, FROMR, PLUS
        .xword      REMAIND, TSTOR
        .xword      SEMIS













        .align 3
N_ACCEP:
        .xword      6
        .ascii      "ACCEPT"
        .align 3
ACCEP:
        .xword    DOCOL
        .xword    ACCEP+HEADSIZE
        .xword    0x0
        .xword    REFTIB
        .xword    N_ACCEP
        .xword    0

        .xword      PACCEP
        .xword      TSWAP, ROT, MIN
        .xword      LDUP, TOR, LMOVE, FROMR
        .xword      SEMIS






        .align 3
N_PACCEP:
        .xword      8
        .ascii      "(ACCEPT)"
        .align 3
PACCEP:
        .xword    DOCOL
        .xword    PACCEP+HEADSIZE
        .xword    0x0
        .xword    ACCEP
        .xword    N_PACCEP
        .xword    0

PACCEP2:
        .xword      REMAIND
        .xword      TFET
        .xword      LIT, ALF, SINDEX
        .xword      ZEQU
        .xword      ZBRAN
        .xword      PACCEP1-.-CW
        .xword      REMAIND, TFET
        .xword      TIB, FETCH
        .xword      SWAP, LMOVE
        .xword      TIB, FETCH
        .xword      REMAIND, CELLP, STOR
        .xword      REFTIB
        .xword      BRAN
        .xword      PACCEP2-.-CW
PACCEP1:
        .xword      REMAIND, TFET
        .xword      LIT, ALF, SSLAS
        .xword      TSWAP, REMAIND, TSTOR
        .xword      SEMIS






        .align 3
N_KEY:
        .xword      3
        .ascii      "KEY"
        .align 3
KEY:
        .xword    DOCOL
        .xword    KEY+HEADSIZE
        .xword    0x0
        .xword    PACCEP
        .xword    N_KEY
        .xword    0

        .xword      ONE, LIT, RAWIO, STTERM 
        .xword      ZERO, SPFET     
        .xword      ZERO            
        .xword      SWAP, ONE       
        .xword      LIT, read, XOS
        .xword      LDUP, QERRUR
        .xword      ZEQU, LIT, -EPIPE, LAND, QERRUR 
        .xword      ONE, LIT, RAWIO, STTERM       
        .xword      SEMIS






        .align 3
N_KEYQ:
        .xword      4
        .ascii      "KEY?"
        .align 3
KEYQ:
        .xword    DOCOL
        .xword    KEYQ+HEADSIZE
        .xword    0x0
        .xword    KEY
        .xword    N_KEYQ
        .xword    0

        .xword      ZERO, LIT, RAWIO, STTERM
        .xword      ZERO, ZERO     
        .xword      LIT, TV, TSTOR
        .xword      ONE 
        .xword      LIT, RFDS, LSTOR
        .xword      ONE     
        .xword      LIT, RFDS
        .xword      ZERO, ZERO  
        .xword      LIT, TV, ZERO, ZERO, LIT, select, XOS7
        
        .xword      LDUP,  QERRUR
        .xword      NEGATE        
        .xword      ZERO, LIT, RAWIO, STTERM
        .xword      SEMIS

        .align 3
RFDS:   .space    (CW*(32))     







        .align 3
N_LTYPE:
        .xword      4
        .ascii      "TYPE"
        .align 3
LTYPE:
        .xword    DOCOL
        .xword    LTYPE+HEADSIZE
        .xword    0x0
        .xword    KEYQ
        .xword    N_LTYPE
        .xword    0

        .xword      LDUP, LOUT, PSTOR
        .xword      ONE, WFILE, THROW
        .xword      SEMIS






        .align 3
N_ETYPE:
        .xword      5
        .ascii      "ETYPE"
        .align 3
ETYPE:
        .xword    DOCOL
        .xword    ETYPE+HEADSIZE
        .xword    0x0
        .xword    LTYPE
        .xword    N_ETYPE
        .xword    0

        .xword      TWO, WFILE, THROW
        .xword      SEMIS






        .align 3
N_EMIT:
        .xword      4
        .ascii      "EMIT"
        .align 3
EMIT:
        .xword    DOCOL
        .xword    EMIT+HEADSIZE
        .xword    0x0
        .xword    ETYPE
        .xword    N_EMIT
        .xword    0

        .xword      SPFET, ONE, LTYPE
        .xword      DROP
        .xword      SEMIS







        .align 3
N_TERMIO:
        .xword      6
        .ascii      "TERMIO"
        .align 3
TERMIO:
        .xword    DOVAR
        .xword    TERMIO+HEADSIZE
        .xword    0x0
        .xword    EMIT
        .xword    N_TERMIO
        .xword    0

        .space    SIZE_TERMIO     






        .align 3
N_STTERM:
        .xword      8
        .ascii      "SET-TERM"
        .align 3
STTERM:
        .xword    DOCOL
        .xword    STTERM+HEADSIZE
        .xword    0x0
        .xword    TERMIO
        .xword    N_STTERM
        .xword    0

SIZEL   = 4     
        .xword      LIT, (TERMIO+HEADSIZE)+SIZEL*3
        .xword      SWAP, TOGGL
        .xword      LIT, (TERMIO+HEADSIZE)+SIZEL*4+7
        .xword      CSTOR
        .xword      ZERO, LIT, TCSETS, TERMIO
        .xword      LIT, ioctl, XOS, QERRUR
        .xword      SEMIS










        #








        .align 3
N_DERR:
        .xword      10
        .ascii      "DISK-ERROR"
        .align 3
DERR:
        .xword    DOVAR
        .xword    DERR+HEADSIZE
        .xword    0x0
        .xword    STTERM
        .xword    N_DERR
        .xword    0

        .xword      -1







        .align 3
N_BLFL:
        .xword      10
        .ascii      "BLOCK-FILE"
        .align 3
BLFL:
        .xword    DOVAR
        .xword    BLFL+HEADSIZE
        .xword    0x0
        .xword    DERR
        .xword    N_BLFL
        .xword    0

        .xword      9
        .ascii      "forth.lab"
        .space    252-9               





        .align 3
N_BHAN:
        .xword      12
        .ascii      "BLOCK-HANDLE"
        .align 3
BHAN:
        .xword    DOVAR
        .xword    BHAN+HEADSIZE
        .xword    0x0
        .xword    BLFL
        .xword    N_BHAN
        .xword    0

        .xword      -1






        .align 3
N_QDSKER:
        .xword      11
        .ascii      "?DISK-ERROR"
        .align 3
QDSKER:
        .xword    DOCOL
        .xword    QDSKER+HEADSIZE
        .xword    0x0
        .xword    BHAN
        .xword    N_QDSKER
        .xword    0

        .xword      LIT, 8, QERR
        .xword      SEMIS








        .align 3
N_BLINI:
        .xword      10
        .ascii      "BLOCK-INIT"
        .align 3
BLINI:
        .xword    DOCOL
        .xword    BLINI+HEADSIZE
        .xword    0x0
        .xword    QDSKER
        .xword    N_BLINI
        .xword    0

        .xword      BLFL, SFET, DTRAI
        .xword      ROT
        .xword      OFILE
        .xword      ZEQU, NEGATE  
        .xword      LWARN, FETCH, MIN 
        .xword      LWARN, STOR
        .xword      BHAN, STOR
        .xword      MTBUF
        .xword      SEMIS






        .align 3
N_BLEXI:
        .xword      10
        .ascii      "BLOCK-EXIT"
        .align 3
BLEXI:
        .xword    DOCOL
        .xword    BLEXI+HEADSIZE
        .xword    0x0
        .xword    BLINI
        .xword    N_BLEXI
        .xword    0

        .xword      FLUSH
        .xword      BHAN, FETCH
        .xword      CFILE
        .xword      ZERO, LWARN, STOR
        .xword      LIT, -1, BHAN, STOR    
        .xword      QDSKER
        .xword      SEMIS






        .align 3
N_BLSEEK:
        .xword      6
        .ascii      "BLSEEK"
        .align 3
BLSEEK:
        .xword    DOCOL
        .xword    BLSEEK+HEADSIZE
        .xword    0x0
        .xword    BLEXI
        .xword    N_BLSEEK
        .xword    0

        .xword      BBUF
        .xword      USTAR
        .xword      BHAN, FETCH
        .xword      PFILE           
        .xword      QDSKER
        .xword      SEMIS






        .align 3
N_BLREAD:
        .xword      10
        .ascii      "BLOCK-READ"
        .align 3
BLREAD:
        .xword    DOCOL
        .xword    BLREAD+HEADSIZE
        .xword    0x0
        .xword    BLSEEK
        .xword    N_BLREAD
        .xword    0

        .xword      BLSEEK 
        .xword      BBUF
        .xword      BHAN, FETCH
        .xword      RFILE           
        .xword      SWAP, BBUF, UNEQ
        .xword      LOR, QDSKER
        .xword      SEMIS






        .align 3
N_BLWRITE:
        .xword      11
        .ascii      "BLOCK-WRITE"
        .align 3
BLWRITE:
        .xword    DOCOL
        .xword    BLWRITE+HEADSIZE
        .xword    0x0
        .xword    BLREAD
        .xword    N_BLWRITE
        .xword    0

        .xword      BLSEEK 
        .xword      BBUF
        .xword      BHAN, FETCH
        .xword      WFILE           
        .xword      QDSKER
        .xword      SEMIS







        .align 3
N_SHELL:
        .xword      5
        .ascii      "SHELL"
        .align 3
SHELL:
        .xword    DOVAR
        .xword    SHELL+HEADSIZE
        .xword    0x0
        .xword    BLWRITE
        .xword    N_SHELL
        .xword    0

                 .xword      7
        .ascii      "/bin/sh"

        .space    252-9               








        .align 3
N_SYSTEM:
        .xword      6
        .ascii      "SYSTEM"
        .align 3
SYSTEM:
        .xword    DOCOL
        .xword    SYSTEM+HEADSIZE
        .xword    0x0
        .xword    SHELL
        .xword    N_SYSTEM
        .xword    0

          .xword      LIT, COMBUF, SSTOR, ZERO, LIT, COMBUF, CHAPP
          .xword      ZERO, SHELL, CHAPP, LIT, -1, SHELL, PSTOR

         .xword      ZERO, ZERO, ZERO, ZERO, ZERO, LIT, clone, XOS5
          .xword      LDUP, QERRUR
          .xword      LDUP, ZEQU
          .xword      ZBRAN
        .xword      SYSTEM1-.-CW
        .xword      SHELL, CELLP, LIT, SYSARGS

      .xword      ARGS, FETCH, SFET, ONEP, LCELLS, PLUS
        .xword      LIT, execve, XOS
        .xword      LIT, 49, LERROR, BYE   
SYSTEM1:


        .xword      LDUP   
        .xword      LIT, P_PID, SWAP
        .xword      LIT, SIGINFOT
        .xword      LIT, WEXITED, ZERO
        .xword      LIT, waitid, XOS5
        .xword      LDUP
        .xword      LIT, EINTR, EQUAL
        .xword      BRAN
        .xword      SYSTEM2-.-CW
        .xword      DROP
        .xword      ZBRAN
        .xword      SYSTEM1-.-CW
SYSTEM2:
        .xword      QERRUR
        .xword      TDROP
        .xword      SEMIS

        .align 3
SIGINFOT: .space    CW*9
SYSARG2: .ascii     "-c"
         .byte      0
        .align 3
COMBUF:  .space    CW+256  
        .align 3
SYSARGS:.xword   (SHELL+HEADSIZE)+CW, SYSARG2, COMBUF + CW, 0

 
















        .align 3
N_ITICK:
        .xword      1
        .ascii      "'"
        .align 3
ITICK:
        .xword    DOCOL 
        .xword    ITICK+HEADSIZE
        .xword    0x0
        .xword    SYSTEM
        .xword    N_ITICK
        .xword    0

        .xword      LNAME, PRESENT
        .xword      LDUP, ZEQU
        .xword      LIT, 11, QERR
        .xword      SEMIS






        .align 3
N_BTICK:
        .xword      3
        .ascii      "[']"
        .align 3
BTICK:
        .xword    DOCOL
        .xword    (TICK+HEADSIZE)
        .xword    B_IMMED
        .xword    ITICK
        .xword    N_BTICK
        .xword    0







        .align 3
N_FORGV:
        .xword      10
        .ascii      "FORGET-VOC"
        .align 3
FORGV:
        .xword    DOCOL
        .xword    FORGV+HEADSIZE
        .xword    0x0
        .xword    BTICK
        .xword    N_FORGV
        .xword    0

        .xword      TDUP
        .xword      SWAP
        .xword      ULESS
        .xword      ZBRAN
        .xword      FORGV1-.-CW

        .xword      SWAP
        .xword      TOR
        .xword      TWID
FORGV0:
        .xword      LDUP
        .xword      LDUP
FORGV3:
        .xword      TLFA,FETCH
        .xword      LDUP
        .xword      RR
        .xword      ULESS
        .xword      ZBRAN
        .xword      FORGV3-.-CW
        .xword      SWAP            
        .xword      TLFA
        .xword      STOR           
        .xword      TLFA,FETCH
        .xword      LDUP
        .xword      ZEQU
        .xword      ZBRAN
        .xword      FORGV0-.-CW        
        .xword      DROP
        .xword      FROMR
        .xword      BRAN
        .xword      FORGV2-.-CW
FORGV1:

        .xword      TVFA
        .xword      FETCH     
        .xword      VOCL
        .xword      STOR
        .xword      ONLY, FORTH
        .xword      DEFIN
FORGV2: .xword      SEMIS






        .align 3
N_FORG:
        .xword      6
        .ascii      "FORGET"
        .align 3
FORG:
        .xword    DOCOL
        .xword    FORG+HEADSIZE
        .xword    0x0
        .xword    FORGV
        .xword    N_FORG
        .xword    0

        .xword      TICK
        .xword      LDUP
        .xword      FENCE
        .xword      FETCH
        .xword      LESS
        .xword      LIT, 21, QERR
        .xword      LIT,FORGV
        .xword      FORV
        .xword      TNFA, FETCH, LDP, STOR
        .xword      SEMIS






        .align 3
N_PBACK:
        .xword      5
        .ascii      "(BACK"
        .align 3
PBACK:
        .xword    DOCOL
        .xword    PBACK+HEADSIZE
        .xword    0x0
        .xword    FORG
        .xword    N_PBACK
        .xword    0

        .xword      HERE
        .xword      SEMIS






        .align 3
N_BACKP:
        .xword      5
        .ascii      "BACK)"
        .align 3
BACKP:
        .xword    DOCOL
        .xword    BACKP+HEADSIZE
        .xword    0x0
        .xword    PBACK
        .xword    N_BACKP
        .xword    0

        .xword      HERE
        .xword      CELLP
        .xword      LSUB
        .xword      COMMA
        .xword      SEMIS






        .align 3
N_PFORWARD:
        .xword      8
        .ascii      "(FORWARD"
        .align 3
PFORWARD:
        .xword    DOCOL
        .xword    PFORWARD+HEADSIZE
        .xword    0x0
        .xword    BACKP
        .xword    N_PFORWARD
        .xword    0

        .xword      HERE
        .xword      X
        .xword      COMMA
        .xword      SEMIS






        .align 3
N_FORWARDP:
        .xword      8
        .ascii      "FORWARD)"
        .align 3
FORWARDP:
        .xword    DOCOL
        .xword    FORWARDP+HEADSIZE
        .xword    0x0
        .xword    PFORWARD
        .xword    N_FORWARDP
        .xword    0

        .xword      HERE
        .xword      OVER
        .xword      CELLP
        .xword      LSUB
        .xword      SWAP
        .xword      STOR
        .xword      SEMIS






        .align 3
N_BEGIN:
        .xword      5
        .ascii      "BEGIN"
        .align 3
BEGIN:
        .xword    DOCOL
        .xword    BEGIN+HEADSIZE
        .xword    B_IMMED
        .xword    FORWARDP
        .xword    N_BEGIN
        .xword    0

        .xword      PBACK
        .xword      QCOMP, ONE
        .xword      SEMIS






        .align 3
N_THEN:
        .xword      4
        .ascii      "THEN"
        .align 3
THEN:
        .xword    DOCOL
        .xword    THEN+HEADSIZE
        .xword    B_IMMED
        .xword    BEGIN
        .xword    N_THEN
        .xword    0

        .xword      QCOMP, TWO, QPAIR
        .xword      FORWARDP
        .xword      SEMIS






        .align 3
N_DO:
        .xword      2
        .ascii      "DO"
        .align 3
DO:
        .xword    DOCOL
        .xword    DO+HEADSIZE
        .xword    B_IMMED
        .xword    THEN
        .xword    N_DO
        .xword    0

         .xword      LIT, XDO, COMMA, PFORWARD, PBACK
        .xword      QCOMP, LIT,3    
        .xword      SEMIS






        .align 3
N_QDO:
        .xword      3
        .ascii      "?DO"
        .align 3
QDO:
        .xword    DOCOL
        .xword    QDO+HEADSIZE
        .xword    B_IMMED
        .xword    DO
        .xword    N_QDO
        .xword    0

         .xword      LIT, XQDO, COMMA, PFORWARD, PBACK
        .xword      QCOMP, LIT,3    
        .xword      SEMIS






        .align 3
N_LLOOP:
        .xword      4
        .ascii      "LOOP"
        .align 3
LLOOP:
        .xword    DOCOL
        .xword    LLOOP+HEADSIZE
        .xword    B_IMMED
        .xword    QDO
        .xword    N_LLOOP
        .xword    0

        .xword      LIT, ONE, COMMA 
        .xword      PLOOP
        .xword      SEMIS






        .align 3
N_PLOOP:
        .xword      5
        .ascii      "+LOOP"
        .align 3
PLOOP:
        .xword    DOCOL
        .xword    PLOOP+HEADSIZE
        .xword    B_IMMED
        .xword    LLOOP
        .xword    N_PLOOP
        .xword    0

        .xword      QCOMP, LIT, 3, QPAIR
        .xword      LIT, XPLOOP, COMMA
        .xword      LIT, ZBRAN, COMMA, BACKP
        .xword      LIT, UNLOOP, COMMA
        .xword      FORWARDP 
        .xword      SEMIS






        .align 3
N_UNTIL:
        .xword      5
        .ascii      "UNTIL"
        .align 3
UNTIL:
        .xword    DOCOL
        .xword    UNTIL+HEADSIZE
        .xword    B_IMMED
        .xword    PLOOP
        .xword    N_UNTIL
        .xword    0

        .xword      QCOMP, ONE, QPAIR
        .xword      LIT, ZBRAN, COMMA, BACKP
        .xword      SEMIS






        .align 3
N_AGAIN:
        .xword      5
        .ascii      "AGAIN"
        .align 3
AGAIN:
        .xword    DOCOL
        .xword    AGAIN+HEADSIZE
        .xword    B_IMMED
        .xword    UNTIL
        .xword    N_AGAIN
        .xword    0

        .xword      QCOMP, ONE, QPAIR
        .xword      LIT, BRAN, COMMA, BACKP
        .xword      SEMIS






        .align 3
N_REPEA:
        .xword      6
        .ascii      "REPEAT"
        .align 3
REPEA:
        .xword    DOCOL
        .xword    REPEA+HEADSIZE
        .xword    B_IMMED
        .xword    AGAIN
        .xword    N_REPEA
        .xword    0

        .xword      QCOMP, ONE, QPAIR   
        .xword      LIT, BRAN, COMMA, BACKP
        .xword      LIT, 4, QPAIR 
        .xword      FORWARDP 
        .xword      SEMIS






        .align 3
N_LIF:
        .xword      2
        .ascii      "IF"
        .align 3
LIF:
        .xword    DOCOL
        .xword    LIF+HEADSIZE
        .xword    B_IMMED
        .xword    REPEA
        .xword    N_LIF
        .xword    0

        .xword      LIT, ZBRAN, COMMA, PFORWARD
        .xword      QCOMP, TWO     
        .xword      SEMIS






        .align 3
N_LELSE:
        .xword      4
        .ascii      "ELSE"
        .align 3
LELSE:
        .xword    DOCOL
        .xword    LELSE+HEADSIZE
        .xword    B_IMMED
        .xword    LIF
        .xword    N_LELSE
        .xword    0

        .xword      QCOMP, TWO, QPAIR
        .xword      LIT, BRAN, COMMA, PFORWARD
        .xword      SWAP
        .xword      FORWARDP
        .xword      TWO     
        .xword      SEMIS






        .align 3
N_LWHILE:
        .xword      5
        .ascii      "WHILE"
        .align 3
LWHILE:
        .xword    DOCOL
        .xword    LWHILE+HEADSIZE
        .xword    B_IMMED
        .xword    LELSE
        .xword    N_LWHILE
        .xword    0

        .xword      QCOMP, LDUP, ONE, QPAIR
        .xword      TOR    
        .xword      TOR
        .xword      LIT, ZBRAN, COMMA, PFORWARD
        .xword      LIT, 4 
        .xword      FROMR
        .xword      FROMR
        .xword      SEMIS






        .align 3
N_SPACES:
        .xword      6
        .ascii      "SPACES"
        .align 3
SPACES:
        .xword    DOCOL
        .xword    SPACES+HEADSIZE
        .xword    0x0
        .xword    LWHILE
        .xword    N_SPACES
        .xword    0

        .xword      ZERO
        .xword      MAX
        .xword      ZERO
        .xword     XQDO
        .xword      SPAX1-.-CW
SPAX2:  .xword      SPACE
        .xword     ONE, XPLOOP, ZBRAN
        .xword      SPAX2-.-CW
	.xword      UNLOOP    
SPAX1:
        .xword      SEMIS






        .align 3
N_BDIGS:
        .xword      2
        .ascii      "<#"
        .align 3
BDIGS:
        .xword    DOCOL
        .xword    BDIGS+HEADSIZE
        .xword    0x0
        .xword    SPACES
        .xword    N_BDIGS
        .xword    0

        .xword      PAD
        .xword      HLD
        .xword      STOR
        .xword      SEMIS






        .align 3
N_EDIGS:
        .xword      2
        .ascii      "#>"
        .align 3
EDIGS:
        .xword    DOCOL
        .xword    EDIGS+HEADSIZE
        .xword    0x0
        .xword    BDIGS
        .xword    N_EDIGS
        .xword    0

        .xword      DROP
        .xword      DROP
        .xword      HLD
        .xword      FETCH
        .xword      PAD
        .xword      OVER
        .xword      LSUB
        .xword      SEMIS






        .align 3
N_SIGN:
        .xword      4
        .ascii      "SIGN"
        .align 3
SIGN:
        .xword    DOCOL
        .xword    SIGN+HEADSIZE
        .xword    0x0
        .xword    EDIGS
        .xword    N_SIGN
        .xword    0

        .xword      ZLESS
        .xword      ZBRAN
        .xword      SIGN1-.-CW 
        .xword      LIT, AMS
        .xword      HOLD    
SIGN1:  .xword      SEMIS






        .align 3
N_DIG:
        .xword      1
        .ascii      "#"
        .align 3
DIG:
        .xword    DOCOL
        .xword    DIG+HEADSIZE
        .xword    0x0
        .xword    SIGN
        .xword    N_DIG
        .xword    0

        .xword      BASE
        .xword      FETCH
        .xword      MSMOD
        .xword      ROT
        .xword      LIT,9
        .xword      OVER
        .xword      LESS
        .xword      ZBRAN
        .xword      DIG1-.-CW  
        .xword      LIT,7
        .xword      PLUS    
DIG1:   .xword      LIT,0x30
        .xword      PLUS
        .xword      HOLD
        .xword      SEMIS






        .align 3
N_DIGS:
        .xword      2
        .ascii      "#S"
        .align 3
DIGS:
        .xword    DOCOL
        .xword    DIGS+HEADSIZE
        .xword    0x0
        .xword    DIG
        .xword    N_DIGS
        .xword    0

DIGS1:  .xword      DIG     
        .xword      OVER
        .xword      OVER
        .xword      LOR
        .xword      ZEQU
        .xword      ZBRAN
        .xword      DIGS1-.-CW 
        .xword      SEMIS







        .align 3
N_PDDOTR:
        .xword      5
        .ascii      "(D.R)"
        .align 3
PDDOTR:
        .xword    DOCOL
        .xword    PDDOTR+HEADSIZE
        .xword    0x0
        .xword    DIGS
        .xword    N_PDDOTR
        .xword    0

        .xword      TOR
        .xword      SWAP
        .xword      OVER
        .xword      DABS
        .xword      BDIGS
        .xword      DIGS
        .xword      ROT
        .xword      SIGN
        .xword      EDIGS
        .xword      FROMR
        .xword      OVER
        .xword      LSUB, ZERO, MAX
        .xword      ZERO
        .xword     XQDO
        .xword      PDDOT1-.-CW
PDDOT2:  .xword      LBL, HOLD  
        .xword     ONE, XPLOOP, ZBRAN
        .xword      PDDOT2-.-CW
	.xword      UNLOOP
PDDOT1:
        .xword      EDIGS  
        .xword      SEMIS






        .align 3
N_DDOTR:
        .xword      3
        .ascii      "D.R"
        .align 3
DDOTR:
        .xword    DOCOL
        .xword    DDOTR+HEADSIZE
        .xword    0x0
        .xword    PDDOTR
        .xword    N_DDOTR
        .xword    0

        .xword      PDDOTR
        .xword      LTYPE
        .xword      SEMIS






        .align 3
N_DOTR:
        .xword      2
        .ascii      ".R"
        .align 3
DOTR:
        .xword    DOCOL
        .xword    DOTR+HEADSIZE
        .xword    0x0
        .xword    DDOTR
        .xword    N_DOTR
        .xword    0

        .xword      TOR
        .xword      STOD
        .xword      FROMR
        .xword      DDOTR
        .xword      SEMIS






        .align 3
N_DDOT:
        .xword      2
        .ascii      "D."
        .align 3
DDOT:
        .xword    DOCOL
        .xword    DDOT+HEADSIZE
        .xword    0x0
        .xword    DOTR
        .xword    N_DDOT
        .xword    0

        .xword      ZERO
        .xword      DDOTR
        .xword      SPACE
        .xword      SEMIS






        .align 3
N_DOT:
        .xword      1
        .ascii      "."
        .align 3
DOT:
        .xword    DOCOL
        .xword    DOT+HEADSIZE
        .xword    0x0
        .xword    DDOT
        .xword    N_DOT
        .xword    0

        .xword      STOD
        .xword      DDOT
        .xword      SEMIS






        .align 3
N_QUES:
        .xword      1
        .ascii      "?"
        .align 3
QUES:
        .xword    DOCOL
        .xword    QUES+HEADSIZE
        .xword    0x0
        .xword    DOT
        .xword    N_QUES
        .xword    0

        .xword      FETCH
        .xword      DOT
        .xword      SEMIS






        .align 3
N_UDOT:
        .xword      2
        .ascii      "U."
        .align 3
UDOT:
        .xword    DOCOL
        .xword    UDOT+HEADSIZE
        .xword    0x0
        .xword    QUES
        .xword    N_UDOT
        .xword    0

        .xword      ZERO
        .xword      DDOT
        .xword      SEMIS






        .align 3
N_FORW:
        .xword      9
        .ascii      "FOR-WORDS"
        .align 3
FORW:
        .xword    DOCOL
        .xword    FORW+HEADSIZE
        .xword    0x0
        .xword    UDOT
        .xword    N_FORW
        .xword    0

        .xword      SWAP
        .xword      TOR
        .xword      TOR
FORW1:  .xword      FROMR
        .xword      RR
        .xword      OVER
        .xword      TLFA
        .xword      FETCH
        .xword      TOR
        .xword      EXEC
        .xword      RR
        .xword      ZEQU
        .xword      ZBRAN
        .xword      FORW1-.-CW
        .xword      RDROP
        .xword      RDROP
        .xword      SEMIS






        .align 3
N_FORV:
        .xword      8
        .ascii      "FOR-VOCS"
        .align 3
FORV:
        .xword    DOCOL
        .xword    FORV+HEADSIZE
        .xword    0x0
        .xword    FORW
        .xword    N_FORV
        .xword    0

        .xword      TOR
        .xword      VOCL
        .xword      FETCH
        .xword      TOR
FORV1:  .xword      FROMR
        .xword      RR
        .xword      OVER
        .xword      TVFA
        .xword      FETCH
        .xword      TOR
        .xword      EXEC
        .xword      RR
        .xword      ZEQU
        .xword      ZBRAN
        .xword      FORV1-.-CW
        .xword      RDROP
        .xword      RDROP
        .xword      SEMIS






        .align 3
N_WORDS:
        .xword      5
        .ascii      "WORDS"
        .align 3
WORDS:
        .xword    DOCOL
        .xword    WORDS+HEADSIZE
        .xword    0x0
        .xword    FORV
        .xword    N_WORDS
        .xword    0

        .xword      CSLL
        .xword      LOUT
        .xword      STOR
        .xword      ZERO            
        .xword      LIT, NOOP
        .xword      CONTEXT
        .xword      FETCH
        .xword      FORW
WORDS1:
        .xword      LDUP
        .xword      ZBRAN
        .xword      WORDS2-.-CW
        .xword      IDDOT
        .xword      BRAN
        .xword      WORDS1-.-CW
WORDS2:
        .xword DROP
        .xword      SEMIS








        .align 3
N_XCODE:
        .xword      9
        .ascii      "EXIT-CODE"
        .align 3
XCODE:
        .xword    DOVAR
        .xword    XCODE+HEADSIZE
        .xword    0x0
        .xword    WORDS
        .xword    N_XCODE
        .xword    0

        .xword      0







        .align 3
N_BYE:
        .xword      3
        .ascii      "BYE"
        .align 3
BYE:
        .xword    DOCOL
        .xword    BYE+HEADSIZE
        .xword    0x0
        .xword    XCODE
        .xword    N_BYE
        .xword    0


        .xword      XCODE, FETCH, X, X, LIT, exit, XOS
        .xword      SEMIS   







        .align 3
N_LLIST:
        .xword      4
        .ascii      "LIST"
        .align 3
LLIST:
        .xword    DOCOL
        .xword    LLIST+HEADSIZE
        .xword    0x0
        .xword    BYE
        .xword    N_LLIST
        .xword    0

        .xword      BASE, FETCH, TOR
        .xword      DECA
        .xword      SCR,STOR

        .xword      SKIP
         .xword      6
SB3: .ascii      "SCR # "
       .align 3
        .xword      LIT, SB3
        .xword      LIT, 6
        .xword      LTYPE
        .xword      SCR, FETCH, DOT
        .xword      SCR, FETCH, BLOCK, BBUF

        .xword      LIT, 16, ZERO
        .xword     XDO
        .xword      LLIST9-.-CW
LLIST1: .xword      LIT, ALF, SSLAS
        .xword      CR, IDO, LIT, 2, DOTR
        .xword      SPACE, LTYPE
        .xword     ONE, XPLOOP, ZBRAN
        .xword      LLIST1-.-CW
	.xword      UNLOOP
LLIST9:
        .xword      TDROP
        .xword      FROMR, BASE, STOR
        .xword      SEMIS






        .align 3
N_INDEX:
        .xword      5
        .ascii      "INDEX"
        .align 3
INDEX:
        .xword    DOCOL
        .xword    INDEX+HEADSIZE
        .xword    0x0
        .xword    LLIST
        .xword    N_INDEX
        .xword    0

        .xword      LIT,AFF
        .xword      EMIT,CR
        .xword      ONEP,SWAP
        .xword     XDO
        .xword      INDE9-.-CW
INDE1:  .xword      CR,IDO
        .xword      LIT,3
        .xword      DOTR,SPACE
        .xword      ZERO,IDO
        .xword      PLINE, LTYPE
        .xword     ONE, XPLOOP, ZBRAN
        .xword      INDE1-.-CW
	.xword      UNLOOP
INDE9:
        .xword      SEMIS






        .align 3
N_DOTS:
        .xword      2
        .ascii      ".S"
        .align 3
DOTS:
        .xword    DOCOL
        .xword    DOTS+HEADSIZE
        .xword    0x0
        .xword    INDEX
        .xword    N_DOTS
        .xword    0

        .xword      CR
        .xword      LIT, 'S', EMIT
        .xword      LIT, ASO, EMIT
        .xword      SPACE
        .xword      SPFET, SZERO, FETCH
DOC2:   .xword      OVER, OVER,  LSUB, ZLESS
        .xword      ZBRAN
        .xword      DOC1-.-CW
        .xword      ZERO, CELLP, LSUB, LDUP, FETCH
        .xword      DOT
        .xword      BRAN
        .xword      DOC2-.-CW
DOC1:    .xword DROP, DROP
        .xword      LIT, ASC, EMIT
        .xword SEMIS






        .align 3
N_ENVQ:
        .xword      12
        .ascii      "ENVIRONMENT?"
        .align 3
ENVQ:
        .xword    DOCOL
        .xword    ENVQ+HEADSIZE
        .xword    0x0
        .xword    DOTS
        .xword    N_ENVQ
        .xword    0

        .xword      LIT, ENV, TWID, PFIND
        .xword      TOR, TDROP, FROMR
        .xword      LDUP
        .xword      ZBRAN
        .xword      ENVQ1-.-CW
        .xword      EXEC
        .xword      LIT, -1
ENVQ1:
        .xword      SEMIS










        .align 3
N_SIGNON:
        .xword      7
        .ascii      ".SIGNON"
        .align 3
SIGNON:
        .xword    DOCOL
        .xword    SIGNON+HEADSIZE
        .xword    0x0
        .xword    ENVQ
        .xword    N_SIGNON
        .xword    0


        .xword      CR
        .xword      BASE,FETCH
        .xword      LIT,36, BASE,STOR
        .xword      LCPU, DDOT
        .xword      BASE,STOR

        .xword      LENAME, LTYPE, SPACE
        .xword      LVERSION, LTYPE, SPACE
        .xword      CR
        .xword      SEMIS









        .align 3
N_TASK:
        .xword      4
        .ascii      "TASK"
        .align 3
TASK:
        .xword    DOCOL
        .xword    TASK+HEADSIZE
        .xword    0x0
        .xword    SIGNON
        .xword    N_TASK
        .xword    0

        .xword      SEMIS







        .align 3
N_TICK:
        .xword      1
        .ascii      "'"
        .align 3
TICK:
        .xword    DOCOL
        .xword    TICK+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    0
        .xword    N_TICK
        .xword    0

        .xword      ITICK
        .xword      LITER
        .xword      SEMIS






        .align 3
N_DCHAR:
        .xword      1
        .ascii      "&"
        .align 3
DCHAR:
        .xword    DOCOL
        .xword    DCHAR+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    TICK
        .xword    N_DCHAR
        .xword    0

        .xword      PPFET
        .xword      NIP
        .xword      LDUP, QBL
        .xword      LIT, 10, QERR
        .xword      LITER
        .xword      QDELIM
        .xword      SEMIS







        .align 3
N_DCTL:
        .xword      1
        .ascii      "^"
        .align 3
DCTL:
        .xword    DOCOL
        .xword    DCTL+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    DCHAR
        .xword    N_DCTL
        .xword    0

        .xword      PPFET
        .xword      NIP
        .xword      LDUP, QBL
        .xword      LIT, 10, QERR
        .xword      LIT, '@', LSUB
        .xword      LITER
        .xword      QDELIM
        .xword      SEMIS






        .align 3
N_DEN0:
        .xword      1
        .ascii      "0"
        .align 3
DEN0:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DCTL
        .xword    N_DEN0
        .xword    0





        .align 3
N_DEN1:
        .xword      1
        .ascii      "1"
        .align 3
DEN1:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN0
        .xword    N_DEN1
        .xword    0





        .align 3
N_DEN2:
        .xword      1
        .ascii      "2"
        .align 3
DEN2:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN1
        .xword    N_DEN2
        .xword    0





        .align 3
N_DEN3:
        .xword      1
        .ascii      "3"
        .align 3
DEN3:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN2
        .xword    N_DEN3
        .xword    0





        .align 3
N_DEN4:
        .xword      1
        .ascii      "4"
        .align 3
DEN4:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN3
        .xword    N_DEN4
        .xword    0





        .align 3
N_DEN5:
        .xword      1
        .ascii      "5"
        .align 3
DEN5:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN4
        .xword    N_DEN5
        .xword    0





        .align 3
N_DEN6:
        .xword      1
        .ascii      "6"
        .align 3
DEN6:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN5
        .xword    N_DEN6
        .xword    0






        .align 3
N_DEN7:
        .xword      1
        .ascii      "7"
        .align 3
DEN7:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN6
        .xword    N_DEN7
        .xword    0





        .align 3
N_DEN8:
        .xword      1
        .ascii      "8"
        .align 3
DEN8:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN7
        .xword    N_DEN8
        .xword    0





        .align 3
N_DEN9:
        .xword      1
        .ascii      "9"
        .align 3
DEN9:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN8
        .xword    N_DEN9
        .xword    0





        .align 3
N_DENA:
        .xword      1
        .ascii      "A"
        .align 3
DENA:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEN9
        .xword    N_DENA
        .xword    0





        .align 3
N_DENB:
        .xword      1
        .ascii      "B"
        .align 3
DENB:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DENA
        .xword    N_DENB
        .xword    0






        .align 3
N_DENC:
        .xword      1
        .ascii      "C"
        .align 3
DENC:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DENB
        .xword    N_DENC
        .xword    0





        .align 3
N_DEND:
        .xword      1
        .ascii      "D"
        .align 3
DEND:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DENC
        .xword    N_DEND
        .xword    0





        .align 3
N_DENE:
        .xword      1
        .ascii      "E"
        .align 3
DENE:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DEND
        .xword    N_DENE
        .xword    0





        .align 3
N_DENF:
        .xword      1
        .ascii      "F"
        .align 3
DENF:
        .xword    DOCOL
        .xword    LNUMB
        .xword    B_IMMED + B_DENOT
        .xword    DENE
        .xword    N_DENF
        .xword    0







        .align 3
N_DENM:
        .xword      1
        .ascii      "-"
        .align 3
DENM:
        .xword    DOCOL
        .xword    DENM+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    DENF
        .xword    N_DENM
        .xword    0

        .xword      PNUMB, DNEGA, SDLITE
        .xword      SEMIS






        .align 3
N_DENP:
        .xword      1
        .ascii      "+"
        .align 3
DENP:
        .xword    DOCOL
        .xword    DENP+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    DENM
        .xword    N_DENP
        .xword    0

        .xword      PNUMB, SDLITE
        .xword      SEMIS






        .align 3
N_DENQ:
        .xword      1
        .ascii      "\""
        .align 3
DENQ:
        .xword    DOCOL
        .xword    DENQ+HEADSIZE
        .xword    B_IMMED + B_DENOT
        .xword    DENP
        .xword    N_DENQ
        .xword    0

        .xword      LIT, SKIP, COMMA        
        .xword      HERE, TOR, ZERO, COMMA
DENQ1:
        .xword      LIT, '"', PARSE         
        .xword      PPFET, LDUP, LIT, '"', EQUAL 
        .xword      ZBRAN
        .xword      DENQ2-.-CW                 
        .xword      TDROP, ONEP             
        .xword      LDUP, ALLOT, RR, SADD
        .xword      BRAN
        .xword      DENQ1-.-CW                  
DENQ2:
        .xword      QBL, ZEQU
        .xword      LIT, 10, QERR           
        .xword      DROP                    
        .xword      LDUP, ALLOT, RR, SADD     
    .xword LALIGN
        .xword      FROMR, SFET, DLITE      
        .xword      SEMIS







        .align 3
N_FORTH:
        .xword      5
        .ascii      "FORTH"
        .align 3
FORTH:
        .xword    DODOE
        .xword    FORTH+HEADSIZE
        .xword    0x0
        .xword    DENQ
        .xword    N_FORTH
        .xword    0

        .xword      DOVOC
        .xword      0       

        .align 3

        .xword    0x0
        .xword    0
        .xword    B_DUMMY
        .xword    TASK
        .xword    (ZERO+(CW*(D_HOFFSET)))
        .xword    0


STARTOFONLY    = FORTH







        .align 3
N_CORE:
        .xword      4
        .ascii      "CORE"
        .align 3
CORE:
        .xword    DOCOL
        .xword    CORE+HEADSIZE
        .xword    0x0
        .xword    0
        .xword    N_CORE
        .xword    0

        .xword      ZERO    
        .xword      SEMIS






        .align 3
N_LCPU:
        .xword      3
        .ascii      "CPU"
        .align 3
LCPU:
        .xword    DOCOL
        .xword    LCPU+HEADSIZE
        .xword    0x0
        .xword    CORE
        .xword    N_LCPU
        .xword    0

             
       .xword      LIT, 0x0113F684, ZERO      
        .xword      SEMIS






        .align 3
N_LVERSION:
        .xword      7
        .ascii      "VERSION"
        .align 3
LVERSION:
        .xword    DOCOL
        .xword    LVERSION+HEADSIZE
        .xword    0x0
        .xword    LCPU
        .xword    N_LVERSION
        .xword    0

 /* 

        .xword      SKIP
        .xword      22
IBMPC:  .ascii     "IBM-PC ciforth"
        .byte      FIGREL+0x40,ADOT,FIGREV+0x30,ADOT,USRVER+0x30
        .xword      LIT, IBMPC, LIT, 22
 */  
        .xword      SKIP
         .xword      5
SB4: .ascii      "5.4.1"
       .align 3
        .xword      LIT, SB4
        .xword      LIT, 5
        .xword      SEMIS






        .align 3
N_LENAME:
        .xword      4
        .ascii      "NAME"
        .align 3
LENAME:
        .xword    DOCOL
        .xword    LENAME+HEADSIZE
        .xword    0x0
        .xword    LVERSION
        .xword    N_LENAME
        .xword    0

        .xword      SKIP
         .xword      7
SB5: .ascii      "ciforth"
       .align 3
        .xword      LIT, SB5
        .xword      LIT, 7
        .xword      SEMIS






        .align 3
N_SUPPLIER:
        .xword      8
        .ascii      "SUPPLIER"
        .align 3
SUPPLIER:
        .xword    DOCOL
        .xword    SUPPLIER+HEADSIZE
        .xword    0x0
        .xword    LENAME
        .xword    N_SUPPLIER
        .xword    0

        .xword      SKIP
         .xword      40
SB6: .ascii      "Albert van der Horst/Frans van der Markt"
       .align 3
        .xword      LIT, SB6
        .xword      LIT, 40
        .xword      SEMIS

STARTOFENVIRONMENT    =   SUPPLIER


 

 /* 

The remaining memory ( up to 'EM' ) is
used for:

        1. EXTENSION DICTIONARY
        2. PARAMETER STACK
        3. TERMINAL INPUT BUFFER
        4. RETURN STACK
        5. USER VARIABLE AREA
        6. DISK BUFFERS (UNLESS REQUIRED <1 MBYTE)


 */  






FORTHSIZE       =     . - _main



       .bss 

INITDP:                 
                        
        BUFFERSIZE      =  (KBBUF+2*CW)*NBUF


        .space    EM - FORTHSIZE - TAS - BUFFERSIZE 





        .space    STACKSIZE - US    
INITS0:                         
STRTIB: .space    TIBSIZE     
        .space    STACKSIZE       
INITR0:                         
STRUSA: .space    US              
BUF1:   .space    BUFFERSIZE      
ACTUAL_EM:  

        




        #
 /* 

  MISC. NOTES AND SCATTERED THOUGHTS

- Remember that all the FORTH words in this version are
  upper case letters.  Use <CAPS LOCK> when in FORTH.



- Subscribe to FORTH Dimensions.  It is a valuable source
  of system and application ideas.  Talking with fellow
  FORTH programmers is sure to stir up some exciting ideas.
  Consider joining a FIG chapter.  See the back of FORTH
  Dimensions for more info.

 */  

        
        # _ORIG
































